 *= $8000
; 
; D:MISSILEC.ASM
; 
; System equates
;
; OS EQUATES
; ----------
; 
; Syntax:
; Use '=' for addresses
; and '#' for values
; 
; 1=Atari 8 bit
; 0=Atari 5200
;
ATARI_8  = 1
OLD_END  = 0

;
; PAGE 0
; 
ATRACT   = $004D

H_SCORE  = $0080	; $80-$82
BONUSFLG = $0083
TKBFLAG  = $0084
NUMPLRS  = $0085
BNSLEVEL = $0086
SMRTFLAG = $0087
STRFLG   = $0088
ZP89     = $0089
ZP8A     = $008A
ZP8B     = $008B
ZP8C     = $008C
ZP8D     = $008D
ZP8E     = $008E
ZP8F     = $008F
ZP90     = $0090
ZP91     = $0091
ZP94     = $0094
ZP95     = $0095
ZP96     = $0096
ZP98     = $0098
ZP99     = $0099
ZP9A     = $009A
ZP9B     = $009B
CURSOR_Y = $009D
CURSOR_X = $009C
ZPC3     = $00C3
ZPC8     = $00C8
ZPC9     = $00C9
ZPCA     = $00CA
ZPD6     = $00D6
ZPD7     = $00D7
ZPD8     = $00D8
CURLEV   = $00D9
ZPDA     = $00DA
ZPDB     = $00DB
P1_SCORE = $00DC	; $DC-DE
BONUSVAR = $00DF	; Bonus city adder
B_CITIES = $00E0
ZPE7     = $00E7
SND_TMP  = $00E8
SND_FLAG = $00E9
ROT_COL2 = $00EA

ZPEB     = $00EB
ZPEC     = $00EC
ZPED     = $00ED
ZPEE     = $00EE
CURPLR   = $00EF
ZPF0     = $00F0
PAUSED   = $00F1
CUR_ON   = $00F2
TIMER1   = $00F3
P2_SCORE = $00F4	; $F4-F6
ZPF8     = $00F8
; 
; HARDWARE REGISTERS
;

 .IF ATARI_8
;--------------------------------------
; Atari 8 Bit
;--------------------------------------

POKMSK   = $0010
ZP13     = $0013
; 
; GTIA
; 
HPOSP0   = $D000
HPOSP1   = $D001
HPOSP2   = $D002
HPOSP3   = $D003
HPOSM0   = $D004
HPOSM1   = $D005
HPOSM2   = $D006
HPOSM3   = $D007
SIZEP0   = $D008
SIZEP1   = $D009
SIZEP2   = $D00A
SIZEP3   = $D00B
SIZEM    = $D00C
GRAFP0   = $D00D
GRAFP1   = $D00E
GRAFP2   = $D00F
GRAFP3   = $D010
GRAFM    = $D011
COLPM0   = $D012
COLPM1   = $D013
COLPM2   = $D014
COLPM3   = $D015
COLPF0   = $D016
COLPF1   = $D017
COLPF2   = $D018
COLPF3   = $D019
COLBK    = $D01A
PRIOR    = $D01B
VDELAY   = $D01C
GRACTL   = $D01D
HITCLR   = $D01E
CONSOL   = $D01F

OFFSETP0 = $CFF1		; crazy offset
; 
; POKEY
; 
AUDF1    = $D200
AUDC1    = $D201
AUDF2    = $D202
AUDC2    = $D203
AUDF3    = $D204
AUDC3    = $D205
AUDF4    = $D206
AUDC4    = $D207
AUDCTL   = $D208
KBCODE   = $D209
RANDOM   = $D20A
POTGO    = $D20B
SEROUT   = $D20D
IRQEN    = $D20E
SKCTL    = $D20F
; 
; PIA
; 
PORTA    = $D300
PORTB    = $D301
PACTL    = $D302
PBCTL    = $D303
; 
; ROM VECTORS
; 
DSKINV   = $E453
CIOV     = $E456
SIOV     = $E459
SETVBV   = $E45C
SYSVBV   = $E45F
XITVBV   = $E462
SIOINV   = $E465
SENDEV   = $E468
INTINV   = $E46B
CIOINV   = $E46E
SELFSV   = $E471
WARMSV   = $E474
COLDSV   = $E477
RBLOKV   = $E47A
CSOPIV   = $E47D
PUPDIV   = $E480
SELFTSV  = $E483
PENTV    = $E486
PHUNLV   = $E489
PHINIV   = $E48C
GPDVV    = $E48F
; 
; PAGE 2
; 
VDSLST   = $0200
VKEYBD   = $0208
SDMCTL   = $022F
SDLSTL   = $0230
SDLSTH   = $0231
GPRIOR   = $026F
PADDL0   = $0270
PADDL1   = $0271
PADDL2   = $0272
PADDL3   = $0273
PADDL4   = $0274
PADDL5   = $0275
PADDL6   = $0276
PADDL7   = $0277
STICK0   = $0278
STICK1   = $0279
STICK2   = $027A
STICK3   = $027B
PTRIG0   = $027C
PTRIG1   = $027D
PTRIG2   = $027E
PTRIG3   = $027F
PTRIG4   = $0280
PTRIG5   = $0281
PTRIG6   = $0282
PTRIG7   = $0283
STRIG0   = $0284
STRIG1   = $0285
STRIG2   = $0286
STRIG3   = $0287
PCOLR0   = $02C0
PCOLR1   = $02C1
PCOLR2   = $02C2
PCOLR3   = $02C3
COLOR0   = $02C4
COLOR1   = $02C5
COLOR2   = $02C6
COLOR3   = $02C7
COLOR4   = $02C8

 .ELSE
;--------------------------------------
; Atari 5200
;--------------------------------------
;        KBCODE
;Key     bits    Keypad code
;-------------------
;none    0000    $FF
;#       0001    $0B
;0       0010    $00
;*       0011    $0A
;Reset   0100    $0E
;9       0101    $09
;8       0110    $08
;7       0111    $07
;Pause   1000    $0D
;6       1001    $06
;5       1010    $05
;4       1011    $04
;Start   1100    $0C
;3       1101    $03
;2       1110    $02
;1       1111    $01

ZP13     = $01
POKMSK   = $00
; 
; GTIA 5200
; 
HPOSP0   = $C000
HPOSP1   = $C001
HPOSP2   = $C002
HPOSP3   = $C003
HPOSM0   = $C004
HPOSM1   = $C005
HPOSM2   = $C006
HPOSM3   = $C007
SIZEP0   = $C008
SIZEP1   = $C009
SIZEP2   = $C00A
SIZEP3   = $C00B
SIZEM    = $C00C
GRAFP0   = $C00D
GRAFP1   = $C00E
GRAFP2   = $C00F
GRAFP3   = $C010
GRAFM    = $C011
COLPM0   = $C012
COLPM1   = $C013
COLPM2   = $C014
COLPM3   = $C015
COLPF0   = $C016
COLPF1   = $C017
COLPF2   = $C018
COLPF3   = $C019
COLBK    = $C01A
PRIOR    = $C01B
VDELAY   = $C01C
GRACTL   = $C01D
HITCLR   = $C01E
CONSOL   = $C01F

OFFSETP0 = $BFF1		; crazy offset

; 
; POKEY 5200
; 
AUDF1    = $E800
AUDC1    = $E801
AUDF2    = $E802
AUDC2    = $E803
AUDF3    = $E804
AUDC3    = $E805
AUDF4    = $E806
AUDC4    = $E807
AUDCTL   = $E808
KBCODE   = $E809
RANDOM   = $E80A
POTGO    = $E80B
SEROUT   = $E80D
IRQEN    = $E80E
SKCTL    = $E80F
; 
; PIA
; 
PORTA    = $D300
PORTB    = $D301
PACTL    = $D302
PBCTL    = $D303

; 
; PAGE 2
; 
VDSLST   = $0206
VKEYBD   = $0208
SDLSTL   = $0005	; ???
SDLSTH   = $0006	; ???
SDMCTL   = $0007
VVBLKD   = $0204	; Vblank deferred
VKYBDF   = $020A	; Deferred Keyboard

GPRIOR   = $026F
PADDL0   = $11
PADDL1   = $12
PADDL2   = $13
PADDL3   = $14
PADDL4   = $15
PADDL5   = $16
PADDL6   = $17
PADDL7   = $18
STICK0   = $0278
STICK1   = $0279
STICK2   = $027A
STICK3   = $027B
PTRIG0   = $027C
PTRIG1   = $027D
PTRIG2   = $027E
PTRIG3   = $027F
PTRIG4   = $0280
PTRIG5   = $0281
PTRIG6   = $0282
PTRIG7   = $0283
STRIG0   = $0284
STRIG1   = $0285
STRIG2   = $0286
STRIG3   = $0287
PCOLR0   = $08
PCOLR1   = $09
PCOLR2   = $0A
PCOLR3   = $0B
COLOR0   = $0C
COLOR1   = $0D
COLOR2   = $0E
COLOR3   = $0F
COLOR4   = $10

CARTNM   = $BFE8	;Cartridge Name Area
COPYD    = $BFFC	;Copyright Decade in Cart
COPYR    = $BFFD	;Copyright Year in Cart
					; $FF=Diagnostic Cart
GOCART   = $BFFE	;Cartridge Start Vector

 .ENDIF
;--------------------------------------

; 
; ANTIC
; 
DMACLT   = $D400
CHACTL   = $D401
DLISTL   = $D402
DLISTH   = $D403
HSCROL   = $D404
VSCROL   = $D405
PMBASE   = $D407
CHBASE   = $D409
WSYNC    = $D40A
VCOUNT   = $D40B
PENH     = $D40C
PENV     = $D40D
NMIEN    = $D40E
NMIRES   = $D40F
;
; Code equates
;
L0000    = $0000
L0094    = $0094
L0097    = $0097
L0098    = $0098
L0099    = $0099
L009A    = $009A
L009B    = $009B
L009C    = $009C
L009D    = $009D
L009E    = $009E
L009F    = $009F

VBL_FLAG = $00A0

L00A1    = $00A1
L00A2    = $00A2
L00A3    = $00A3
L00A4    = $00A4
L00A5    = $00A5
L00A6    = $00A6
L00A7    = $00A7
L00A8    = $00A8
L00A9    = $00A9
L00AA    = $00AA
L00AB    = $00AB
L00AC    = $00AC
L00AD    = $00AD
L00AE    = $00AE
L00AF    = $00AF
L00B0    = $00B0
L00B1    = $00B1
L00B9    = $00B9
L00BC    = $00BC
L00CB    = $00CB
L00CC    = $00CC

BASE_CNT = $600
BASE_TMP = $601
BASE_IDX = $602
FIRE_A   = $603
FIRE_B   = $604
FIRE_C   = $605
ATR_MODE = $606
MTIMER2  = $607
TIMER2   = $608
CON_BUTN = $609
;PAUSE    = $60A
ATR_FIRE = $60B
ATR_IDX  = $60C
ATR_JOY  = $60D
ATR_DIS  = $60E
ATR_AUTO = $60F

NEW_P1   = $620
CITIES   = $620      ; $E1-E6 $620-$63F
CUR_MS   = $62A      ; $00CD
REM_BASE = CUR_MS+3  ; $00CE
NEW_P2   = $630

L00CE    = $00CE
L00CF    = $00CF

L00D0    = $00D0	; PM colors/colors
L00D1    = $00D1
L00D2    = $00D2
L00D3    = $00D3
L00D4    = $00D4
L00D5    = $00D5

L0480    = $0480
L0488    = $0488
L0493    = $0493
L049B    = $049B
L04A6    = $04A6
L04AE    = $04AE
L04B9    = $04B9
L04CC    = $04CC
L04DF    = $04DF
L04E7    = $04E7
L04EF    = $04EF
L04F2    = $04F2
L0505    = $0505
L0515    = $0515
L0518    = $0518
L052B    = $052B
L053E    = $053E
L0552    = $0552
L0566    = $0566
L057A    = $057A
L058E    = $058E
L05A2    = $05A2
L05AA    = $05AA
L05B2    = $05B2
L05BA    = $05BA
L05BB    = $05BB

L05C2    = $05C2			; Sound data
L05C3    = $05C3
L05CA    = $05CA
L05CB    = $05CB

L0600    = $0600
L08C0    = $08C0
L08C1    = $08C1
L0990    = $0990
L0D00    = $0D00
L0D01    = $0D01
L0F00    = $0F00
;
; Pointers to display memory
;
TXT_MEM  = $1004			; Text
PTXT_MEM = $102D			; Players
LTXT_MEM = $1034			; Level
TTXT_MEM = $1036			; Stick/Ball
BTXT_MEM = $103B			; Bonus
STXT_MEM = $102B			; Smart Bomb only
LAND_MEM = $1EC8			; Ground

LFEFE    = $FEFE

;
; Start of code
;
STRGAME
         SEI

         LDA #$06
         STA $1D
         LDA #$00
         STA $1C
         TAY
CLRALL   STA ($1C),Y		; Clear $0600-$3f00
         DEY
         BNE CLRALL
         INC $1D
         LDX $1D
         CPX #$3F
         BNE CLRALL

?CLRPG0  STA $0,Y
         DEY
         BNE ?CLRPG0

         LDA #$2E
         STA SDMCTL			; DMA Control
         LDA #$03
         STA GRACTL			; Enable PM
         LDA #$11
         STA GPRIOR			; Graphics Priority
         LDA #$08
         STA PMBASE			; Player Missile Base Address
         LDA #<DLIVEC
         STA VDSLST			; DLI = $B22A
         LDA #>DLIVEC
         STA VDSLST+1

 .IF ATARI_8
;--------------------------------------
; Atari 8 Bit
;--------------------------------------

         LDA #$07
         LDX #>VBLVEC
         LDY #<VBLVEC
         JSR SETVBV			; Set the VBL = $B1DA
         LDA #$C0
         STA NMIEN			; Enable DLI/VBI
         LDA #<KEYVEC
         STA VKEYBD			; Set Keyboard vector = $B195
         LDA #>KEYVEC
         STA VKEYBD+1
 .ELSE
;--------------------------------------
; Atari 5200
;--------------------------------------

         LDA #<VBLVEC
         STA VVBLKD
         LDA #>VBLVEC
         STA VVBLKD+1       
         LDA #<KEYVEC
         STA VKYBDF			; Set Keyboard vector = $B195
         LDA #>KEYVEC
         STA VKYBDF+1
         LDA #$C0
         STA NMIEN			; Enable DLI/VBI
 .ENDIF
;--------------------------------------

         LDA #$40
         STA POKMSK			; Set POKEY mask
         STA IRQEN			; Interrupt Enable
         CLI

         LDA #$10
         STA ZP89			; $89 = #$10
         LDA #$0D
         STA ZP8A			; $8A = #$0D

         LDA #$75			; default HS = 7500
         STA H_SCORE+1

         LDX #$00
         LDY #$00
         STX ZP94
LA84D    STX ZP95
         STX ZP98
         STX ZP99
         TXA
         ASL A
         TAX
         TYA
         ADC ZP89
         STA ZP89
         STA L0D00,X
         LDA #$00
         ADC ZP8A
         STA ZP8A
         STA L0D01,X
         LDY #$00
         INX
         TXA
         STA (ZP89),Y
         INY
         LDA ZP95
         LSR A
         STA ZP9A
         CLC
         ADC #$02
         STA (ZP89),Y
         INY
         STA ZPC3
         LDX ZP94
LA87D    LDA ZP9A
         STA ZP9B
LA881    LDA LBBF5,X
         STA (ZP89),Y
         INY
         INX
         DEC ZP9B
         BPL LA881
         LDA #$FF
         STA (ZP89),Y
         INY
         DEC ZP99
         BPL LA87D
         STX ZP94
         STY ZP99
LA899    DEC ZP98
         BMI LA8BB
         LDA ZP99
         SEC
         SBC ZPC3
         SBC ZPC3
         STA ZP99
         LDX ZPC3
LA8A8    STY ZP9A
         LDY ZP99
         LDA (ZP89),Y
         INY
         STY ZP99
         LDY ZP9A
         STA (ZP89),Y
         INY
         DEX
         BNE LA8A8
         BEQ LA899
LA8BB    LDX ZP95
         INX
         CPX #$08
         BNE LA84D
         LDY #$10
         LDA #$40
         LDX #$00
LA8C8    PHA
         STA L08C0,X
         TYA
         STA L08C1,X
         PLA
         INX
         INX
         CPX #$C0
         BEQ INTRO
         CLC
         ADC #$28
         BCC LA8C8
         INY
         BCS LA8C8
        
INTRO
         LDA #$01
         STA ATR_MODE
         LDA #$00
         STA ATR_AUTO
         STA CON_BUTN
         STA SND_FLAG
         
; JMP LA8DF
         LDX #$00
         LDA #$00
?INT_CLR STA TXT_MEM,x
         INX
         BNE ?INT_CLR

         JSR CLR_MEM
         LDA #$34
         STA COLOR0
         STA COLOR1
         LDA #$00
         STA COLOR4

         LDA #<DLIST2		; Set Display List $BF90
         STA SDLSTL
         LDA #>DLIST2
         STA SDLSTH
         
         LDX #$00
         STX BASE_CNT
         LDA #$18
         STA BASE_TMP
?INT_LP  LDA MS_ARY1,X		; Draw "MISSILE"
         STA ZP8B
         INX
         LDA MS_ARY1,X
         STA ZP8C
         INX
         STX BASE_CNT
         
         LDX #$1A
         CLC
         LDA BASE_TMP
         TAY
         ADC #16
         STA BASE_TMP
         LDA #$55
         JSR DRAW
 
         LDX BASE_CNT
         CPX #$0E
         BNE ?INT_LP

         LDX #$00
         STX BASE_CNT
         LDA #$10
         STA BASE_TMP
?INT_LP2 LDA MS_ARY2,X		; Draw "COMMAND+"
         STA ZP8B
         INX
         LDA MS_ARY2,X
         STA ZP8C
         INX
         STX BASE_CNT
         
         LDX #$30
         CLC
         LDA BASE_TMP
         TAY
         ADC #16
         STA BASE_TMP
         LDA #$55
         JSR DRAW
 
         LDX BASE_CNT
         CPX #$10
         BNE ?INT_LP2
   
         LDA #$0C
         STA ROT_COL2
         LDA #$16
         STA ZP94

?INTRO8  LDA RANDOM
         AND #$1F
         CLC
         ADC #$1F
         STA L00B0
         LDA RANDOM
         AND #$7F
         CLC
         ADC #$10
         STA L00AF
         LDX ZP94
         STX ZP98
         JSR LATTR
         LDX #$10
         JSR LB2D9
         LDA CON_BUTN
         BNE ?L001
         DEC ZP94
         BPL ?INTRO8

         LDX #$F0			; Delay???
         JSR LB2D9
         
         LDY CON_BUTN
M_SCREEN
         LDA #$00
         STA CON_BUTN
?L001
         LDX #$F
         LDA #$00
?CLRPG   STA NEW_P1,X
         STA NEW_P2,X
         DEX
         BPL ?CLRPG
         
LA8DF    LDA #<DL_INTRO		; DLIST1
         STA SDLSTL			; Display List = $BF80
         LDA #>DL_INTRO
         STA SDLSTH

         CPY #0
         BNE LA915
                                  
         LDX #$3B
LA8EB    LDA MISSTXT,X		; Print 'Missile Command...'
         STA TXT_MEM,X
         DEX
         BPL LA8EB
         
         JSR CHK_OPT
         
         LDA NUMPLRS
         CLC
         ADC #$11
         STA PTXT_MEM		; Display # Players
         LDA BNSLEVEL
         CLC
         ADC #$10
         STA LTXT_MEM		; Display Level
         LDA BONUSFLG
         BEQ LA915
         LDX #$04
         LDA #$00
LA90F    STA BTXT_MEM,X
         DEX
         BPL LA90F
       
LA915    LDA #$00			; Clear Page Zero Memory?
         LDX #$89
LA919    STA L0000,X
         INX
         BNE LA919        
         DEX
         TXS
LA920    STA L0990,X
         STA L0F00,X
         DEX
         BNE LA920

         CPY #$00
         BNE ?NO_TXT

         LDX #13
?DEF     LDA DEF_TXT,X		; Print 'Defend Cities'
         STA $F00+143,X
         DEX
         BPL ?DEF

         LDX #$09
?EXTR    LDA HS_TXT,X		; Print 'HIGH SCORE'
         STA $F00+5,X
         DEX
         BPL ?EXTR

         LDX #H_SCORE		; High Score = $80-$82
         LDA #$06
         JSR PSCORE2		; Print Hight Score
?NO_TXT
         LDA #$0C
         STA ROT_COL2
         LDA #$06
         STA ZPF8
         STA B_CITIES
         
         CLC
         LDA CURLEV
         ADC BNSLEVEL
         STA CURLEV
         LDA BNSLEVEL
         LSR A
         CLC
         ADC ZPDA
         STA ZPDA
;
; MAIN LOOP
;         
LA93F
         JSR INIT_GAME		; Draw Cities/Base etc...

         LDA ATR_MODE
         BEQ ?SKIP_ARW
      
         JSR DRW_ARW
?SKIP_ARW
         LDA ATR_MODE		; attract mode?
         BNE ?N002

         LDA CON_BUTN		; during game play
         BEQ GO_GAME
         JMP M_SCREEN

?N002    LDA #20			; set time for attract mode
         STA TIMER2
         
L_WAIT   LDA CON_BUTN		; check for start
         BNE ?N003
         LDA TIMER2
         AND #$01
         BEQ ?NOFLSH
         JSR ERS_ARW
         JMP ?GETIME
?NOFLSH  JSR DRW_ARW 
         LDA TIMER2
         CMP #10
         BCS ?GETIME

         LDX #9
         LDA #0
?BNSCLR  STA $F00+5,X
         DEX
         BPL ?BNSCLR

         LDX #33
?BNSSTR  LDA BNS_TXT,X		; Print 'BONUS EVERY 10000 POINTS'
         STA $F00+22,X
         DEX
         BPL ?BNSSTR
        
?GETIME  LDA TIMER2			; timer done so do intro again
         BNE L_WAIT
         LDA #$01
         STA ATR_AUTO
         JSR INIT_GAME
         JMP GO_GAME
         
?N003    CMP #$01			; start button
         BEQ ?WAIT_B
         LDY #$00
         JMP M_SCREEN         

?WAIT_B  LDA #$00
         STA ATR_MODE
         STA ATR_AUTO
         STA CON_BUTN
         STA FIRE_A
         STA FIRE_B
         STA FIRE_C
                  
GO_GAME  LDA #<DLIST2		; Set Display List $BF90
         STA SDLSTL
         LDA #>DLIST2
         STA SDLSTH

         JSR ERS_ARW         
                  
         LDX #$27			; Zero memory $1004-$102A
         LDA #$00
LA954    STA TXT_MEM,X
         STA $F00,X
         DEX
         BPL LA954
         
         LDX #H_SCORE		; High Score = $80-$82
         LDA #$06
         JSR PSCORE			; Print Hight Score

         LDA ATR_MODE
         BNE LA97C         
         LDA NUMPLRS		; If 1 player then branch
         BEQ LA97C
         LDA CURPLR
         TAX
         EOR #$01
         TAY
         LDA PCURNT,X		; Index to Print "<"
         TAX
         LDA #$1C
         STA TXT_MEM,X

         LDA PLRIND,Y	
         LDX #$F4			; Player 2 score = $F4-F6
         JSR PSCORE			; Print Player 2 Score
         
LA97C    LDA #$80			; Initial cursor position
         STA CURSOR_X
         LDY #$3C
         STY CURSOR_Y
         
         LDA #$01
         LDY #$06
         LDX #$00
         JSR DO_SND			; Alarm Sound

         LDA #$62
         STA TIMER1
         STA ZPF0
         
         LDA ATR_MODE
         BNE ?NO_BNS
         LDA #$AA
         JSR DRW_BNS		; Display Level x Bonus
?NO_BNS
         LDA #0
         STA BASE_IDX

LA998    LDX #$00
         STX VBL_FLAG
         STX ATRACT
         DEX
         TXS 
         LDA CON_BUTN		; check for console key during game
         BEQ ?NO_BUTN
         CMP #$20
         BEQ P_GAME
         LDX #$06
?CLRSND  JSR CLR_SND		; Clear Sound
         DEX
         DEX
         BPL ?CLRSND
         LDA #$01
         STA ATR_MODE
         LDY #$00
         JMP M_SCREEN

P_GAME   LDA PAUSED
         BNE P_GAME
         LDA #$00
         STA CON_BUTN

?NO_BUTN LDA CUR_ON			; Cursor on flag
         BEQ LA9A7
         JSR CURSOR			; Process cursor
LA9A7    LDA ZPF0
         BEQ LA9BE
         LDA TIMER1
         BNE LA9BB
         STA ZPF0
         LDX #$00
         JSR CLR_SND		; Turn off Alarm Sound
         LDA #$00
         JSR DRW_BNS		; Erase Level x Bonus
LA9BB    JMP LAF33

LA9BE    LDA CUR_ON
         BNE LA9_X
         JMP LA9D7
LA9_X

.IF ATARI_8
;--------------------------------------
; Atari 8 bit
;--------------------------------------

         LDA ATR_MODE
         BEQ LA9_X1
         LDA ATR_FIRE
         BEQ LA9_X1
         LDA #$00
         STA ATR_FIRE
         JMP ?AUTO_FR

LA9_X1   LDX #$00
         LDA TKBFLAG
         BNE LA9CA
		 LDX CURPLR			; Player pressing fire button?
LA9CA    LDA STRIG0,X
         TAX
         EOR L009E
         AND L009E
         STX L009E
         LSR A
         BCC ?CHK_KEY
;
; Smart Launcher
;
?AUTO_FR LDA L00A5
         BEQ ?CHK_KEY

         LDA CURSOR_X		; Get the X pos.
         SEC
         SBC #$2E
         CMP #$2D
         BCS ?LNCH_N1
         LDX #$00			; Try base A
         BEQ ?LNCH_TY
?LNCH_N1 CMP #$74
         BCS ?LNCH_N2
         LDX #$01			; Try base B
         BNE ?LNCH_TY

?LNCH_N2 LDX #$02			; Try base C

?LNCH_TY LDA CUR_MS,X		; OK to fire?
         BNE ?EX_LNCH
							; 0 ->1,2 1->0,2 2->0,1
         CPX #$00			; Try other bases
         BNE ?LNCH_B1
         LDX #$01			; Try base 'B'
         LDA CUR_MS,X
         BNE ?EX_LNCH
         LDX #$02			; Base 'C'
         BNE ?EX_LNCH

?LNCH_B1 CPX #$01			; Try other bases
         BNE ?LNCH_B2

         LDA CURSOR_X		; Based on closest base first
         SEC
         SBC #$2E
         CMP #$50
         BCS ?LNCH_X

         LDX #$00			; Try base 'A'
         LDA CUR_MS,X
         BNE ?EX_LNCH
         LDX #$02			; Base 'C'
         BNE ?EX_LNCH
?LNCH_X
         LDX #$02			; Try base 'C'
         LDA CUR_MS,X
         BNE ?EX_LNCH
         LDX #$00			; Base 'A'
         BEQ ?EX_LNCH

?LNCH_B2 LDX #$01			; Try base 'B'
         LDA CUR_MS,X
         BNE ?EX_LNCH
         LDX #$00			; Base 'A'     
?EX_LNCH
         STX BASE_IDX
         JMP LAUNCH

?CHK_KEY LDA FIRE_A			; check keys
         BEQ ?CHK_B
         LDA #$00
         STA FIRE_A
         STA BASE_IDX
         BEQ LA9DA
         
?CHK_B   LDA FIRE_B
         BEQ ?CHK_C
         LDA #$0
         STA FIRE_B
         LDA #$1
         STA BASE_IDX
         BNE LA9DA

?CHK_C   LDA FIRE_C
         BEQ LA9D7
         LDA #$0
         STA FIRE_C
         LDA #$2
         STA BASE_IDX
         BNE LA9DA        
                  
.ELSE
;--------------------------------------
; Atari 5200
;--------------------------------------

         LDA ATR_MODE
         BEQ LA9_X1
         LDA ATR_FIRE
         BEQ LA9_X1
         LDA #$00
         STA ATR_FIRE
         JMP ?AUTO_FR
;
; Smart Launcher
;
?AUTO_FR LDA L00A5
         BEQ ?CHK_KEY

         LDA CURSOR_X		; Get the X pos.
         SEC
         SBC #$2E
         CMP #$2D
         BCS ?LNCH_N1
         LDX #$00			; Try base A
         BEQ ?LNCH_TY
?LNCH_N1 CMP #$74
         BCS ?LNCH_N2
         LDX #$01			; Try base B
         BNE ?LNCH_TY

?LNCH_N2 LDX #$02			; Try base C

?LNCH_TY LDA CUR_MS,X		; OK to fire?
         BNE ?EX_LNCH
							; 0 ->1,2 1->0,2 2->0,1
         CPX #$00			; Try other bases
         BNE ?LNCH_B1
         LDX #$01			; Try base 'B'
         LDA CUR_MS,X
         BNE ?EX_LNCH
         LDX #$02			; Base 'C'
         BNE ?EX_LNCH

?LNCH_B1 CPX #$01			; Try other bases
         BNE ?LNCH_B2

         LDA CURSOR_X		; Based on closest base first
         SEC
         SBC #$2E
         CMP #$50
         BCS ?LNCH_X

         LDX #$00			; Try base 'A'
         LDA CUR_MS,X
         BNE ?EX_LNCH
         LDX #$02			; Base 'C'
         BNE ?EX_LNCH
?LNCH_X
         LDX #$02			; Try base 'C'
         LDA CUR_MS,X
         BNE ?EX_LNCH
         LDX #$00			; Base 'A'
         BEQ ?EX_LNCH

?LNCH_B2 LDX #$01			; Try base 'B'
         LDA CUR_MS,X
         BNE ?EX_LNCH
         LDX #$00			; Base 'A'     
?EX_LNCH
         STX BASE_IDX
         JMP LAUNCH

?CHK_KEY
LA9_X1
;         LDA PORTA
;         TAX
;         AND #~00000100
;         BNE ?NO_PTRG
;         LDA #$00
;         STA FIRE_A
;         STA BASE_IDX
;         BEQ LA9DA
;         
;?NO_PTRG TXA
;         AND #~00001000
;         BNE ?NO_PTRG2
;         LDA #$00
;         STA FIRE_B
;         LDA #$1
;         STA BASE_IDX
;         BNE LA9DA
;
;?NO_PTRG2
;         TXA
;         AND #~01000000
;         BNE LA9D7
;         LDA #$00
;         STA FIRE_C
;         LDA #$2
;         STA BASE_IDX
;         BNE LA9DA
         
;--------------------------------------
.ENDIF

LA9D7    JMP LAA46			; No button pressed

LA9DA    LDA L00A5
         BEQ LA9E2
LAUNCH
         LDX BASE_IDX		; Base that fired
         LDA CUR_MS,X		; Missile available then branch
         BNE LA9F3

LA9E2    LDA #$00
         STA AUDCTL
         LDA #$1F
         LDY #$29
         LDX #$04
         JSR DO_SND			; Out of missiles sound
         JMP LAA46

LA9F3    LDY #$07
LA9F5    LDA L0505,Y		; Available launch slot???
         BEQ LA9FE
         DEY
         BPL LA9F5

LA9FE    DEC L00A5
         LDX BASE_IDX
         DEC CUR_MS,X		; Decrement count
         LDA BS_STRX,X
         STA L00AD			; Start X
         LDA #$56
         STA L00AE			; Start Y
         LDX CURSOR_Y
         INX
         STX L00B0			; End Y
         LDA CURSOR_X
         SEC
         SBC #$2D
         STA L00AF			; End X
         JSR LB86F
         
         LDX BASE_IDX
         JSR ERASE_MS		; Erase missile from base

         LDX BASE_IDX
         LDA CUR_MS,X		; Reload base?
         CMP #$03
         BNE ?CHK_OUT
       
         JSR DRW_BASE		; Yes

         LDA #<LOW_TXT		; Point to LOW Text 
         STA ZP8B
         LDA #>LOW_TXT
         STA ZP8C
         JMP ?TXT
         
?CHK_OUT CMP #$00
         BNE LAA23

         JSR DRW_BASE		; Yes

         LDA #<LOW_TXT		; Erase LOW Text 
         STA ZP8B
         LDA #>LOW_TXT
         STA ZP8C
         LDX BASE_IDX
         SEC
         LDA BS_STRX,X
         SBC #6
         TAY				; x
         LDX #$5C			; y
         LDA #$AA
         JSR DRAW

         LDA #<OUT_TXT		; Point to OUT Text 
         STA ZP8B
         LDA #>OUT_TXT
         STA ZP8C
?TXT
         LDX BASE_IDX
         SEC
         LDA BS_STRX,X
         SBC #6
         TAY				; x
         LDX #$5C			; y
         LDA #$55
         JSR DRAW
         
LAA23    LDA #<X_DATA		; X image
         STA ZP8B
         LDA #>X_DATA
         STA ZP8C
         LDX CURSOR_Y		; y
         LDA CURSOR_X		; x
         SEC
         SBC #$2E
         TAY
         LDA #$55
         JSR DRAW			; Draw X on screen ???
       
         LDA #$20
         STA AUDCTL
         LDA #$2E
         LDY #$4C
         LDX #$04
         JSR DO_SND			; Fire missile sound???

LAA46    LDX BASE_IDX
         LDA CUR_MS,X		; Process missiles fired???
		 LDX #$A6
LAA4A    TAY
         CLC
         LDA L08C0,X
         ADC #$13
         STA ZP89
         LDA L08C1,X
         ADC #$00
         STA ZP8A
         TYA
         LDY #$02
LAA5D    ORA (ZP89),Y
         BNE LAA6D
         DEY
         BPL LAA5D
         INX
         INX
         CPX #$B6
         BNE LAA4A
 
         LDX BASE_IDX
         JSR DRW_BASE		; Draw Base

LAA6D    LDX #$02			; Check for collisions???

LAA6F    BNE LAA75
         LDA L00A8
         BNE LAA7D
LAA75    LDA L04EF,X		; Active missile???
         BNE LAA7D
LAA7A    JMP LAB0E

LAA7D    LDA HPOSM1,X		; Get player 1-3 playfield collisions
         AND #$04
         BEQ LAA7A			; none so check next one
         
         LDA #$00			; Hide PM
         STA HPOSP1,X
         STX ZP95
         CPX #$00			; player 0?
         BNE LAAE1			; no, so branch
         LDA L00A8
         BEQ LAAE1
         
         LDA #$01			; Add 100 points
         STA ZP99
         LDA #$00
         JSR ADDSCR			; Add to score
         LDA L00A9
         LSR A
         BCS LAAAB
         LDA #<LBBBE		; $BBBE
         STA ZP8B
         LDA #>LBBBE
         STA ZP8C
         BNE LAAC1
LAAAB    ASL A
         ASL A
         BCS LAAB9
         LDA #<LBB7A		; $BB7A
         STA ZP8B
         LDA #>LBB7A
         STA ZP8C
         BNE LAAC1
LAAB9    LDA #<LBB9C		; $BB9C
         STA ZP8B
         LDA #>LBB9C
         STA ZP8C
LAAC1    LDA L00AA
         SEC
         SBC #$30
         TAY
         LDA #$AA
         LDX L00AB			; Show plane/bomber blown up
         JSR DRAW

         LDA L00AB
         CLC
         ADC #$04
         TAY
         LDA #$00
         STA L00A8
         LDA L00AA
         SEC
         SBC #$2D
         LDX #$18
         BNE LAB05
         
LAAE1    LDA #$01			; Add 125 points
         STA ZP99
         LDA #$25
         JSR ADDSCR			; Add to score
         LDA L00B9,X
         JSR LB944
         TXA
         CLC
         ADC #$10
         TAX
         LDA #$00
         STA L04DF,X
         LDA L0493,X
         CLC
         ADC #$02
         TAY
         LDA L0480,X
         ADC #$02
LAB05    STA L00AF
         STY L00B0
         JSR LB8D4
         LDX ZP95
LAB0E    DEX				; Next player
         BMI LAB14      
         JMP LAA6F			; Loop

LAB14    LDA #$90
         STA ZP8B
         LDA #$09
         STA ZP8C
         LDY #$03			; Player 0-3
         CLC
         LDA #$0E
         ADC L00A1
         TAX

LAB24    STY ZP95
         LDA L04DF,X
         BEQ LAB52
         LDA HPOSP0,Y		; Check for missile playfield collision
         AND #$04
         BEQ LAB52
         
         LDA #$00			; Add 25 points for intercepted missile
         STA ZP99
         LDA #$25
         JSR ADDSCR			; Add to score
         JSR LB8CA
         LDA L00A9,X
         JSR LB944
         LDA L0505,X
         SEC
         SBC L04DF,X
         STA L04DF,X
         BEQ LAB52
         JSR LB76A
LAB52    LDY ZP95
         LDA L00BC,Y
         TAY
         LDA #$00			; Clear PM graphics area
         STA (ZP8B),Y
         DEX
         DEX
         LDY ZP95			; next check
         DEY
         BPL LAB24
         
         LDX #$07
         LDA L00A1
         BEQ LAB6E
         DEX
         LDA #$00
         BEQ LAB70
LAB6E    LDA #$01
LAB70    STA L00A1
         LDY #$03
         LDA #$80
LAB76    STA ZP98
         LDA L04E7,X
         BEQ LAB97
         STY ZP95
         LDA ZP98
         LDY L049B,X
         ORA (ZP8B),Y
         STA (ZP8B),Y
         TYA
         LDY ZP95
         STA L00BC,Y
         LDA L0488,X
         CLC
         ADC #$30
         STA HPOSM0,Y		; store missile x pos
LAB97    LDA ZP98
         LSR A
         LSR A
         DEX
         DEX
         DEY
         BPL LAB76
         
         LDX #$0F
         STX HITCLR
         JSR LB3BE			; Process incoming missiles
         LDX #$07
         JSR LB3BE			; Process incoming missiles
         JSR LB2EB
         
         LDA L00A8
         BNE LAC30
         LDA ZPC8
         BEQ LABBD
         DEC ZPC8
         JMP LAC30
         
LABBD    LDA L00A3
         BEQ LAC30
         LDA L0515
         BNE LAC30
         LDY RANDOM
         CPY #$18
         BCC LAC30
         CPY #$34
         BCS LAC30
         STY L00AB
         LDA RANDOM
         STA L00A9
         LSR A
         BCC LABF3
         ASL A
         ASL A
         BCS LABE9
         LDA #<LBB72		; Plane (right)
         STA ZP8B
         LDA #>LBB72
         STA ZP8C
         BNE LABFB
LABE9    LDA #<LBB94		; Plane (left)
         STA ZP8B
         LDA #>LBB94
         STA ZP8C
         BNE LABFB
LABF3    LDA #<LBBB6		; Alien
         STA ZP8B
         LDA #>LBBB6
         STA ZP8C
LABFB    LDA L00A9
         BMI LAC03
         LDA #$30
         BNE LAC05
LAC03    LDA #$C8
LAC05    STA L00AA
         STA L0515
         STA L00A8
         LDA #$07			; Length
         LDX #$01			; Buffer 1
         JSR DRAW2
         LDA L00AA
         STA HPOSP1
         LDA #$00
         STA L00AC
         LDA ZPD8
         STA ZPC8
         LDA ZPEE
         BNE LAC2D
         LDA #$6F
         LDY #$74
         LDX #$06
         JSR DO_SND			; Bomber Sound
LAC2D    JMP LAD85

LAC30    LDA L00CC			; Do incoming missiles
         BNE LAC37
         JMP LAD67
LAC37    LDA L00A3
         BEQ LAC42
         LDA RANDOM
         AND #$03
         BNE LAC45
LAC42    JMP LACED
LAC45    LDY L00CB
         BNE LAC4C
         JMP LAD5F
LAC4C    LDA L00A8
         BEQ LAC75
         LDA ZPCA
         BEQ LAC58
         DEC ZPCA
         BPL LAC75
LAC58    LDA L00AA
         CMP #$35
         BCC LAC75
         CMP #$C1
         BCS LAC75
         SEC
         SBC #$2C
         TAX
         LDA #$08
         STA ZPCA
         LDA #$FF
         STA ZP95
         LDA L00AB
         CLC
         ADC #$04
         BNE LAC9A
LAC75    LDX #$07
LAC77    LDA L04E7,X
         BEQ LAC87
         LDA L049B,X
         CMP #$18
         BCC LAC87
         CMP #$34
         BCC LAC8C
LAC87    DEX
         BPL LAC77
         BMI LACC8
LAC8C    PHA
         LDA #$00
         STA ZP95
         LDA L00B1,X
         STA ZPC3
         LDA L0488,X
         TAX
         PLA
LAC9A    STA L00AE
         STX L00AD
         STY L0097
LACA0    JSR LB7C9			; Get target x position
         TXA				; target index
         LDY ZP95
         BMI LACB6
LACA8    CMP ZPC3,Y
         BNE LACB3
         JSR LB944
         JMP LACC1
LACB3    DEY
         BPL LACA8
LACB6    LDY ZP95
         INY
         STA ZPC3,Y
         STY ZP95
         JSR LB84F
LACC1    DEC L0097
         BNE LACA0
         JMP LAD5F
LACC8    LDA RANDOM
         CMP #$A0
         BCS LACEA
         LDY #$07
LACD1    LDX L04E7,Y
         BEQ LACDB
         CMP L04AE,Y
         BEQ LACEA
LACDB    DEY
         BPL LACD1
         STA L00AD
         LDA #$08
         STA L00AE
         JSR LB7C9			; Get target x position
         JSR LB84F
LACEA    JMP LAD5F
LACED    LDX L00A7
         BNE LACF4
LACF1    JMP LAD85
LACF4    LDA L00A2
         BEQ LACF1
         LDA RANDOM
         CMP #$9E
         BCS LACF1
         
         LDX #$02
LAD01    LDY L0515,X
         BEQ LAD0C
         DEX
         BPL LAD01
         JMP LAD5F
         
LAD0C    STA L00AD
         LDY #$08
         STY L00AE
         LDA #<SMRT_BM		; Smart bomb image
         STA ZP8B
         LDA #>SMRT_BM
         STA ZP8C
         LDA #$02			; Length
         STX ZP95
         INX				; buffer
         JSR DRAW2
         LDA L00AD
         LDX ZP95
         CLC
         ADC #$30
         STA HPOSP1,X
         JSR LB7C9
         TXA
         INC ZPEE
         DEC L00A2
         DEC L00A7
         LDX ZP95
         STA L00B9,X
         TAX
         CLC
         LDA ZP95
         ADC #$10
         TAY
         LDA X_POS,X
         SEC
         SBC #$02
         STA L00AF
         LDA #$55
         STA L00B0
         JSR LB86F
         LDA #$65
         LDY #$6A
         LDX #$06
         JSR DO_SND			; Smart Bomb Sound
         
         LDA L00CB
         BEQ LAD5F
         DEC L00CB
LAD5F    LDA L00CB
         BNE LAD85
         STA L00CC
         BEQ LAD85
LAD67    DEC ZPC9
         BNE LAD85
         LDA L00A3
         CMP #$05
         BCC LAD73
         LDA #$04
LAD73    CMP L00A6
         BCC LAD79
         LDA L00A6
LAD79    STA L00CB
         ORA L00A2
         BEQ LAD85
         STA L00CC
         LDA ZPD7
         STA ZPC9

LAD85    LDA L00A8
         BEQ LADBF
         LDA ZPD6
         CLC
         ADC L00AC
         STA L00AC
         BCC LADBF
         LDX L00AA
         LDA L00A9
         BMI LAD9F
         INX
         CPX #$C8
         BCS LADAC
         BCC LADA4
LAD9F    DEX
         CPX #$30
         BCC LADAC
LADA4    STX HPOSP1
         STX L00AA
         JMP LADBF
LADAC    LDA #$00
         STA L00A8
         STA HPOSP1
         STA L0515
         LDA ZPEE
         BNE LADBF
         LDX #$06
         JSR CLR_SND
LADBF    LDX #$12
LADC1    LDA L04DF,X
         BNE LADC9
         JMP LAEE9
LADC9    SEC
         LDA L00A4
         ADC L04CC,X
         STA L04CC,X
         BCS LADD7
         JMP LAEE9
LADD7    LDA #$00
         STA ZPC3
         LDA L0493,X
         CMP #$0A
         BCC LAE32
         CMP #$51
         BCS LAE32
         LDA L0480,X
         CMP #$02
         BCC LAE32
         CMP #$99
         BCS LAE32
         LDY #$07
LADF3    STY ZP95
         LDA LBB09,Y
         CLC
         ADC L0480,X
         STA ZP98
         LDA LBB11,Y
         CLC
         ADC L0493,X
         ASL A
         TAY
         LDA L08C0,Y
         STA ZP89
         LDA L08C1,Y
         STA ZP8A
         LDA ZP98
         LSR A
         LSR A
         TAY
         LDA (ZP89),Y
         PHA
         LDA ZP98
         AND #$03
         TAY
         PLA
         AND LBB19,Y
         EOR LBB19,Y
         BNE LAE2A
         SEC
         BCS LAE2B
LAE2A    CLC
LAE2B    ROR ZPC3
         LDY ZP95
         DEY
         BPL LADF3
LAE32    LDA ZPC3
         BEQ LAE3A
         STA L00B0,X
         BNE LAE63
LAE3A    LDA L00B0,X
         BEQ LAE63
         LDA #$00
         STA L00B0,X
         LDY L00A9,X
         LDA X_POS,Y
         SEC
         SBC #$02
         STA L00AF
         LDA #$55
         STA L00B0
         LDA L0480,X
         STA L00AD
         LDA L0493,X
         STA L00AE
         STX ZP95
         TXA
         TAY
         JSR LB86F
         LDX ZP95
LAE63    LDA L00B0,X
         BNE LAE92
         JSR LB95B			; Move Falling Missiles
         DEC L04DF,X
         BEQ LAE72
         JMP LAEBD
LAE72    LDA #$00
         STA OFFSETP0,X		; X offset to D000
         LDY L0480,X
         INY
         INY
         STY L00AF
         LDY L0493,X
         INY
         INY
         STY L00B0
         JSR LB8D4
         STX ZP95
         JSR LB829
         LDX ZP95
         JMP LAEE9
LAE92    LDA ZPC3
         AND #$0F
         BNE LAEA1
         INC L0480,X
         INC L0493,X
         JMP LAEBD
LAEA1    LDA ZPC3
         AND #$F0
         BNE LAEB0
         DEC L0480,X
         INC L0493,X
         JMP LAEBD
LAEB0    AND #$7E
         BNE LAEBA
         INC L0493,X
         JMP LAEBD
LAEBA    DEC L0493,X
LAEBD    LDA L0480,X
         CLC
         ADC #$30
         STA OFFSETP0,X		; X offset to D000
         TXA
         SEC
         SBC #$0F
         ASL A
         TAY
         LDA L0493,X
         SEC
         SBC #$01
         CLC
         ADC DW_BUFLO,Y
         STA ZP89
         LDA #$00
         ADC DW_BUFHI,Y
         STA ZP8A
         LDY #$04
LAEE1    LDA SMRT_BMB,Y		; Copy smart bomb image
         STA (ZP89),Y
         DEY
         BPL LAEE1
LAEE9    DEX
         CPX #$0F
         BEQ LAEF1
         
         JMP LADC1
LAEF1    LDA VBL_FLAG
         BNE LAF36
         
         LDA B_CITIES		; Game over?
         ORA CUR_MS
         ORA CUR_MS+1
         ORA CUR_MS+2
         ORA REM_BASE
         ORA REM_BASE+1
         ORA REM_BASE+2
         BEQ LAF14			;
         
         LDA L00A3
         ORA L00A2
         BNE LAF33
         LDX #$0A
LAF05    ORA L04E7,X
         DEX
         BPL LAF05
         ORA L00A8
         STA CUR_ON
         BNE LAF14
         STA HPOSP0
         
LAF14    LDA #$00
         STA L00A3
         STA L00A2
         LDX #$13
LAF1C    LDA L053E,X
         BPL LAF33
         DEX
         BPL LAF1C
         
         LDA L00A6
         CLC
         ADC L00A7
         ADC L00A5
         CMP #$13
         BNE LAF33
         
         LDA L00A8
         BEQ LAF39

LAF33    JSR C_SCORE		; Print player score
LAF36    JMP LA998

LAF39    LDX #$00
         STX HPOSP0
         LDA ATR_MODE
         BEQ ?DO_CNT
         
         JMP INTRO
         
?DO_CNT  STX B_CITIES
         STX BASE_CNT       ; Number of bases to count
         LDA #$15
         STA ZP96

         LDA #<DLIST4		; Set Display List $BF90
         STA SDLSTL
         LDA #>DLIST4
         STA SDLSTH
         
LAF44    DEC CUR_MS,X		; Add missiles left bonus to score
         BMI LAF6B

         JSR ERASE_MS		; Erase missile
         LDA ZP96			; Move over 4 for each missile
         CLC
         ADC #$04
         STA ZP96
         TAY				; x
         LDX #$20			; y
         LDA #$55
         JSR DRAW			; Draw missile

         LDA #$00			; Add 5 to score for each missile left
         STA ZP99
         LDA #$05
         JSR ADDSCR			; Add score
         LDX #$05
         JSR CNT_SND		; Count sound
         LDX BASE_CNT
         JMP LAF44

LAF6B    LDX BASE_CNT
         LDA REM_BASE,X		; Any bases left?
         BEQ ?L3
         JSR DRW_BASE		; Draw base
         LDX BASE_CNT
         JMP LAF44
         
?L3      INC BASE_CNT
         LDX BASE_CNT
         CPX #$03			; 0-2
         BNE LAF44
         
LAF75    LDA #<CITYDAT		; $BB37
         STA ZP8B
         LDA #>CITYDAT
         STA ZP8C

         LDA #$0B			; City position on bonus screen 
         STA ZP96
         LDX #$05
LAF83    STX ZP95
         LDA CITIES,X
         BMI LAFB4
         INC B_CITIES
         LDA #$00
         LDY CITY_X,X		; x
         LDX #$59			; y
         JSR DRAW			; Erase City

         LDA ZP96			; move over 15 for each city
         CLC
         ADC #$0E
         STA ZP96
         TAY				; x
         LDX #$30			; y
         LDA #$55
         JSR DRAW			; Draw city

         LDA #$01			; Add 100 points for each city left
         STA ZP99
         LDA #$00
         JSR ADDSCR			; Add to score
         LDX #$0F
         JSR CNT_SND		; Count sound
         LDX ZP95
LAFB4    DEX
         BPL LAF83      

         LDA BONUSFLG		; Check for Bonus City
         BEQ LAFBE
         JMP LB045			; No bonus cities...

LAFBE    LDA #$00			; Check to see if bonus has been reached
         STA ZP98
         LDA P1_SCORE+2
         AND #$0F
         STA ZP99
         LDA P1_SCORE+2
         LSR A
         LSR A
         LSR A
         LSR A
         TAX
         LDA #$00
         CPX #$01
         BCC LAFDB
         CLC
LAFD6    ADC #$0A			; Add to bonus (every 10,000)
         DEX
         BNE LAFD6
        
LAFDB    ADC ZP99
         STA ZP99
LAFDF    LDA ZP99
         CMP BONUSVAR
         BEQ LB01C
         LDA B_CITIES
         CMP #$06
         BEQ LB01C
         LDA RANDOM
         LSR A
         AND #$07
         TAX
         BCS LB002
LAFF4    CPX #$06
         BCC LAFFA
         LDX #$05
LAFFA    LDA CITIES,X
         BMI LB010
         DEX
         JMP LAFF4
LB002    CPX #$06
         BCC LB008
         LDX #$00
LB008    LDA CITIES,X
         BMI LB010
         INX
         JMP LB002
LB010    LDA #$00
         STA CITIES,X
         INC B_CITIES
         INC BONUSVAR
         INC ZP98
         BNE LAFDF

LB01C    LDA ZP98
         BEQ LB045

         JSR DRWBNS			; print bonus city
         LDA #$A4
         STA AUDC2
         LDA #$12
         STA ZP9A
LB029    LDA RANDOM
         AND #$1E
         BNE LB032
         LDA #$1E
LB032    ADC #$08
         STA AUDF2
         LDX #$06
         JSR LB580			; Do bonus city sound
         DEC ZP9A
         BPL LB029
         LDA #$00
         STA AUDC2

LB045    LDY B_CITIES
         BNE LB06C
         SEC
         LDA H_SCORE		; Compare high score
         SBC P1_SCORE
         LDA H_SCORE+1
         SBC P1_SCORE+1
         LDA H_SCORE+2
         SBC P1_SCORE+2
         BCS LB061
         LDX #$02
LB05A    LDA P1_SCORE,X		; Current score is high score
         STA H_SCORE,X
         DEX
         BPL LB05A
LB061    LDY B_CITIES
         BNE LB06C
         LDA NUMPLRS		; If # Players = 0 then branch
         BEQ LB069
         LDA ZPF8
         BNE LB074

LB069    JMP LB0AB

LB06C    LDY NUMPLRS		; If # Players = 0 then branch
         BEQ LB089
         LDY ZPF8
         BEQ LB089
LB074    LDX #$0A			; Swap scores
LB076    LDY P2_SCORE,X
         LDA P1_SCORE,X
         STA P2_SCORE,X
         STY P1_SCORE,X
         DEX
         BPL LB076
         LDX #$F
?NEW_LP  LDY NEW_P2,X
         LDA NEW_P1,X
         STA NEW_P2,X
         TYA
         STA NEW_P1,X
         DEX
         BPL ?NEW_LP
         LDA CURPLR
         EOR #$01
         STA CURPLR
         BNE LB0A3
LB089    LDX CURLEV
         INX
         CPX #$15			; Lev 15 max
         BCC LB092
         LDX #$13			; Back to Lev 13
LB092    STX CURLEV
         TXA
         LSR A
         BCS LB0A3
         LDX ZPDA
         INX
         CPX #$0A
         BCC LB0A1
         LDX #$00
LB0A1    STX ZPDA
LB0A3    LDX #$5A
         JSR LB580
         JMP LA93F			; LOOP

.IF OLD_END
;--------------------------------------
         
LB0AB    JSR CLR_MEM		; Clear memory

         LDA #<THEDAT		; $BC63
         STA ZP8B			; "THE"
         LDA #>THEDAT
         STA ZP8C
         LDX #$30
         LDY #$18
         LDA #$55
         JSR DRAW

         LDA #<ENDDAT		; $BD28
         STA ZP8B			; "END"
         LDA #>ENDDAT
         STA ZP8C
         LDX #$30
         LDY #$58
         LDA #$55
         JSR DRAW

         LDA #$0B
         LDY #$10
         LDX #$00
         JSR DO_SND			; Sound
         LDA #$15
         LDY #$10
         LDX #$02
         JSR DO_SND			; Sound
         LDA #$06
         STA ZP95
         LDA #$01
         STA ZP96
LB0F2    LDA ZP96
         STA L0097
         LDA #$00
         STA VBL_FLAG
         LDA RANDOM
         ORA #$08
         AND #$FB
         STA COLOR0
         STA COLOR4
LB107    LDA VBL_FLAG
         BEQ LB107
         DEC L0097
         BEQ LB12B
         
         LDA COLOR4
         AND #$F0
         STA COLOR4
         LDA RANDOM
         AND #$0B
         ORA COLOR4
         STA COLOR4
         STA COLOR0
         LDA #$00
         STA VBL_FLAG
         BEQ LB107
         
LB12B    INC ZP96
         DEC ZP95
         BNE LB0F2
         LDA #$34
         STA COLOR0
         STA COLOR1
         LDA #$FF
         STA L0097
LB13D    LDA #$08
         STA ZP95
LB141    LDA #$00
         STA VBL_FLAG
         LDA RANDOM
         AND L0097
         STA COLOR4
LB14D    LDA VBL_FLAG
         BEQ LB14D
         DEC ZP95
         BNE LB141
         LSR L0097
         BCS LB13D
         
         LDA #$00
         STA COLOR4
         LDA #$FE
         STA ZP13
LB162    LDA ZP13
         BNE LB162

         LDA #$13
         STA ZP94
LB16A    LDA RANDOM
         AND #$1F
         CLC
         ADC #$1F
         STA L00B0
         LDA RANDOM
         AND #$7F
         CLC
         ADC #$10
         STA L00AF
         LDX ZP94
         JSR LB8D4
         LDX #$10
         JSR LB2D9
         DEC ZP94
         BPL LB16A
         
         LDX #$FF
         JSR LB2D9
         
         LDA #$01
         STA ATR_MODE
         LDY #$00
         STY CON_BUTN
         JMP M_SCREEN
;         JMP LA8DF

.ELSE

LB0AB
         LDA #$00
         STA COLOR0
         STA COLOR4

         LDA #<DLIST2		; Set Display List $BF90
         STA SDLSTL
         LDA #>DLIST2
         STA SDLSTH

         LDX #$00
         LDA #128
?CLR_TXT STA TXT_MEM,x
         INX
         BNE ?CLR_TXT
         
         JSR FILL_MEM		; Fill memory

         LDA #<END_OPN1		; 
         STA ZP8B			; 
         LDA #>END_OPN1
         STA ZP8C
         LDX #$1D
         LDY #$20
         LDA #$AA
         JSR DRAW

         LDA #<END_OPN2		; 
         STA ZP8B			; 
         LDA #>END_OPN2
         STA ZP8C
         LDX #$31
         LDY #$20
         LDA #$AA
         JSR DRAW

         LDA #<END_OPN3		; 
         STA ZP8B			; 
         LDA #>END_OPN3
         STA ZP8C
         LDX #$1D
         LDY #$50
         LDA #$AA
         JSR DRAW

         LDA #<END_OPN4		; 
         STA ZP8B			; 
         LDA #>END_OPN4
         STA ZP8C
         LDX #$31
         LDY #$50
         LDA #$AA
         JSR DRAW

         LDA #$34
         STA COLOR0

         LDA #$0B
         LDY #$10
         LDX #$00
         JSR DO_SND			; Sound
         LDA #$15
         LDY #$10
         LDX #$02
         JSR DO_SND			; Sound
         LDA #$06
         STA ZP95
         LDA #$01
         STA ZP96
LB0F2    LDA ZP96
         STA L0097
         LDA #$00
         STA VBL_FLAG
         LDA RANDOM
         ORA #$08
         AND #$FB
         STA COLOR1
LB107    LDA VBL_FLAG
         BEQ LB107
         DEC L0097
         BEQ LB12B
         
         LDA RANDOM
         AND #$0B
         ORA COLOR1
         STA COLOR1
         LDA #$00
         STA VBL_FLAG
         BEQ LB107
         
LB12B    INC ZP96
         DEC ZP95
         BNE LB0F2
         LDA #$FF
         STA L0097
LB13D    LDA #$08
         STA ZP95
LB141    LDA #$00
         STA VBL_FLAG
         LDA RANDOM
         AND L0097
         STA COLOR1
LB14D    LDA VBL_FLAG
         BEQ LB14D
         DEC ZP95
         BNE LB141
         LSR L0097
         BCS LB13D
         
         LDA #$00
         STA COLOR1

         LDA #1
         STA TIMER1
LB162    LDA TIMER1
         BNE LB162
      
         LDX #$FF
         JSR LB2D9
         
         LDA #$01
         STA ATR_MODE
         LDY #$00
         STY CON_BUTN
         JMP M_SCREEN

;--------------------------------------
.ENDIF

;
; Draw/erase arrows pointing to cities
;
ERS_ARW
         LDA #$00
         BEQ ?DO_ARW
DRW_ARW  
         LDA #$AA
?DO_ARW  PHA
         LDA #<ARROW		; Point to arrow image
         STA ZP8B
         LDA #>ARROW
         STA ZP8C
         LDX #$05
?ARW     STX ZP95			; Draw arrows
         LDA ARROW_X,X
         TAY
         LDX #$46			; y
         PLA
         PHA
         JSR DRAW
         LDX ZP95
         DEX
         BPL ?ARW
         PLA
         RTS

 .IF ATARI_8
;--------------------------------------
; Atari 8 Bit
;--------------------------------------

;
; Keyboard Interrupt
;
KEYVEC
         TXA				; Keyboard Interrupt
         PHA
         
         LDA KBCODE
         CMP #$AD			; CTRL-T Trackball
         BNE LB1AE
         STA CON_BUTN
         LDA TKBFLAG
         EOR #$FF
         STA TKBFLAG
         JMP ?KB_EXIT
         
LB1AE    CMP #$3E			; 'S' Smart bomb only
         BNE LB1BB
         STA CON_BUTN
         LDA SMRTFLAG
         EOR #$FF
         STA SMRTFLAG
         JMP ?KB_EXIT

LB1BB    CMP #$01			; 'j'
         BNE ?N_KEY1
         LDA FIRE_A
         EOR #$FF
         STA FIRE_A
         JMP ?KB_EXIT
?N_KEY1  CMP #$05   		; 'k'
         BNE ?N_KEY2
         LDA FIRE_B
         EOR #$FF
         STA FIRE_B
         JMP ?KB_EXIT
?N_KEY2  CMP #$00  			; 'l'
         BNE ?N_KEY
         LDA FIRE_C
         EOR #$FF
         STA FIRE_C
         JMP ?KB_EXIT
?N_KEY   CMP #$48
         BCS ?SPACE
         TAX
         LDA KEYCODE,X
         CMP #$3A			; Check if 0-9 is pressed
         BCS ?SPACE
         CMP #$30
         BCC ?SPACE
         STA CON_BUTN
         SBC #$30
         STA BNSLEVEL		; Save Start Level
         JMP ?KB_EXIT

?SPACE   CMP #$20           ; space bar
         BNE ?KB_EXIT
         STA CON_BUTN
         LDA PAUSED
         EOR #$FF
         STA PAUSED

?KB_EXIT PLA
         TAX
         PLA
         RTI
;
; Vertical Blank Interrupt
;
VBLVEC
         CLD
         LDA #$FF			; Vblank flag
         STA VBL_FLAG

         LDA #$E0
         STA $D409
         
         CLC				; Rotate colors
         LDA ROT_COL2
         ADC #$10
         STA ROT_COL2
         STA COLPF2
         
         DEC TIMER1			; Decrement timer

         LDA MTIMER2
         BEQ ?N_TIMER2
         DEC MTIMER2
         JMP ?N001
?N_TIMER2
         LDA #60			; ~one second 
         STA MTIMER2
         LDA TIMER2
         BEQ ?N001
         DEC TIMER2

?N001
;         LDA RANDOM
;         AND #$0F
;         ORA #$B0
;         STA ICAX2Z
         
;         LDA #$00
;         STA ICAX1Z
;         LDY SKREST
;         NOP
;         NOP

         LDA CONSOL			; Save Console Buttons
         TAY
         EOR L009F
         AND L009F
         STY L009F
        
         LSR A				; Start Button?
         BCS LB221
         
         LSR A				; Select Button?
         BCC LB215
         
         LDA NUMPLRS		; Number of Players 1/2
         EOR #$01
         STA NUMPLRS
         LDA #$02
         JMP ?SETBTN
;         BCS LB21E

LB215    LSR A				; Option Button?
         BCC LB227
         LDA BONUSFLG		; Bonus On/Off
         EOR #$01
         STA BONUSFLG
         LDA #$03
         JMP ?SETBTN
;LB21E    JMP LA8DF

LB221    LDA #$01			; Begin Game
;         STA STRFLG
;         JMP LA915
;         LDA #$01

?SETBTN  STA CON_BUTN
         
LB227    JMP XITVBV
;
; Display List Interrupt
;
DLIVEC
         PHA				; DLI Interrupt
         TXA
         PHA
         TYA
         PHA
         
         CLD
         LDA VCOUNT
         LDX #$04
LB235    CMP LB2D4,X
         BEQ LB270
         BCS LB23F
         DEX
         BPL LB235
LB23F    LDA PAUSED
         BNE LB26D
         LDA PORTA
         TAX
         EOR ZPEB
         AND ZPEB
         STX ZPEB
         LSR A
         LSR A
         BCC LB25D
         TAY
         TXA
         LSR A
         BCC LB25A
         INC ZPEC
         BCS LB25C
LB25A    DEC ZPEC
LB25C    TYA
LB25D    LSR A
         LSR A
         BCC LB26D
         TXA
         AND #$04
         BEQ LB26B
         INC ZPED
         JMP LB26D
LB26B    DEC ZPED
LB26D    JMP LB2CE

LB270    CMP #$66
         BNE LB27B
         LDA L00D2
         STA COLPF1
         BNE LB2CE
LB27B    LDA SND_FLAG		; Process sound?
         BNE LB2CE

         LDX #$07
LB281    LDA L05CA,X
         BEQ LB2CB
         DEC L05CA,X
         BNE LB2CB
         DEC L05BA,X
         BNE LB2B8
         LDY L05C2,X
         BNE LB29B
         TYA
         STA AUDF1,X
         BEQ LB2CB
LB29B    TXA
         PHA
         LDA #$04
         STA SND_TMP
LB2A1    LDA SND_DATA,Y
         STA L05A2,X
         TXA
         CLC
         ADC #$08
         TAX
         INY
         DEC SND_TMP
         BPL LB2A1
         PLA
         TAX
         LDA L05A2,X
         BNE LB2C2
LB2B8    CLC
         LDA L05AA,X
         ADC L05A2,X
         STA L05A2,X
LB2C2    STA AUDF1,X		; Store into pokey register
         LDA L05B2,X
         STA L05CA,X
LB2CB    DEX
         BPL LB281
         
LB2CE    PLA
         TAY
         PLA
         TAX
         PLA
         RTI
         
 .ELSE
;--------------------------------------
; Atari 5200
;--------------------------------------

KEYVEC
         CMP #$0A			; Keyboard Interrupt
         BCS ?KB_NXT
         STA BNSLEVEL		; Save Start Level
         CLC
         ADC #$30
         STA CON_BUTN
         JMP ?KB_EXIT
         
?KB_NXT  CMP #$0E			; RESET
         BNE ?KB_NXT2
         STA CON_BUTN
         LDA TKBFLAG
         EOR #$FF
         STA TKBFLAG
         JMP ?KB_EXIT        
         
?KB_NXT2 CMP #$0D			; PAUSE
         BNE ?KB_NXT3
         STA CON_BUTN
         LDA PAUSED
         EOR #$FF
         STA PAUSED
         JMP ?KB_EXIT

?KB_NXT3 CMP #$0A			; *
         BNE ?KB_NXT4
         STA CON_BUTN
         LDA SMRTFLAG
         EOR #$FF
         STA SMRTFLAG        
         JMP ?KB_EXIT

?KB_NXT4 CMP #$0B			; #
         BNE ?KB_NXT5
         LDA NUMPLRS		; Number of Players 1/2
         EOR #$01
         STA NUMPLRS
         LDA #$02
         STA CON_BUTN
         BNE ?KB_EXIT
         
?KB_NXT5 CMP #$0C			; START
         BNE ?KB_EXIT
         LDA #$1
         STA CON_BUTN

?KB_EXIT
         PLA
         TAY
         PLA
         TAX
         PLA
         RTI

VBLVEC
         CLD
         LDA #$FF			; Vblank flag
         STA VBL_FLAG

         LDA PORTA
         STA PTRIG0
         LDA PORTA+1
         STA PTRIG1
                  
         CLC				; Rotate colors
         LDA ROT_COL2
         ADC #$10
         STA ROT_COL2
         STA COLPF2
         
         DEC TIMER1			; Decrement timer

         LDA MTIMER2
         BEQ ?N_TIMER2
         DEC MTIMER2
         JMP ?N001
?N_TIMER2
         LDA #60			; ~one second 
         STA MTIMER2
         LDA TIMER2
         BEQ ?N001
         DEC TIMER2
?N001       
LB227    PLA
         TAY
         PLA
         TAX
         PLA
         RTI
         
DLIVEC
         PHA				; DLI Interrupt
         TXA
         PHA
         TYA
         PHA
         
         CLD
         LDA VCOUNT
         LDX #$04
LB235    CMP LB2D4,X
         BEQ LB270
         BCS LB23F
         DEX
         BPL LB235
LB23F    LDA PAUSED
         BNE LB26D
         LDA PORTA
         TAX
         EOR ZPEB
         AND ZPEB
         STX ZPEB
         LSR A
         LSR A
         BCC LB25D
         TAY
         TXA
         LSR A
         BCC LB25A
         INC ZPEC
         BCS LB25C
LB25A    DEC ZPEC
LB25C    TYA
LB25D    LSR A
         LSR A
         BCC LB26D
         TXA
         AND #$04
         BEQ LB26B
         INC ZPED
         JMP LB26D
LB26B    DEC ZPED
LB26D    JMP LB2CE

LB270    CMP #$66
         BNE LB27B
         LDA L00D2
         STA COLPF1
         BNE LB2CE
LB27B    LDA SND_FLAG		; Process sound?
         BNE LB2CE

         LDX #$07
LB281    LDA L05CA,X
         BEQ LB2CB
         DEC L05CA,X
         BNE LB2CB
         DEC L05BA,X
         BNE LB2B8
         LDY L05C2,X
         BNE LB29B
         TYA
         STA AUDF1,X
         BEQ LB2CB
LB29B    TXA
         PHA
         LDA #$04
         STA SND_TMP
LB2A1    LDA SND_DATA,Y
         STA L05A2,X
         TXA
         CLC
         ADC #$08
         TAX
         INY
         DEC SND_TMP
         BPL LB2A1
         PLA
         TAX
         LDA L05A2,X
         BNE LB2C2
LB2B8    CLC
         LDA L05AA,X
         ADC L05A2,X
         STA L05A2,X
LB2C2    STA AUDF1,X		; Store into pokey register
         LDA L05B2,X
         STA L05CA,X
LB2CB    DEX
         BPL LB281
         
LB2CE    PLA
         TAY
         PLA
         TAX
         PLA
         RTI
         
 .ENDIF
;--------------------------------------

;
; Print Bonus City
;
DRWBNS  LDX #9
?BNS    LDA BNSCITY,X
        STA $F00+5,X
        DEX
        BPL ?BNS
        RTS
;
;
;                 
LB2D4	.BYTE $06
		.BYTE $28
		.BYTE $49
		.BYTE $66
		.BYTE $6A
        
LB2D9    STX ZPC3
LB2DB    LDA #$00
         STA VBL_FLAG
         JSR LB2EB
LB2E2    LDA VBL_FLAG
         BEQ LB2E2
         DEC ZPC3
         BNE LB2DB
         RTS
LB2EB    LDX L00CF
         INX
         CPX #$0A
         BCC LB2F4
         LDX #$00
LB2F4    STX L00CF
LB2F6    LDY L053E,X
         BPL LB2FE
         JMP LB382
LB2FE    CPY #$08
         BCC LB312
         LDA #$00
         STA L0552,X
         LDY #$07
         DEC L053E,X
         INC L0566,X
         INC L057A,X
LB312    STX ZP95
         TYA
         ASL A
         TAX
         LDA L0D00,X
         STA ZP8B
         LDA L0D01,X
         STA ZP8C
         LDX ZP95
         LDY L0566,X
         CPY #$FF
         BNE LB331
         LDY #$9F
         DEC L057A,X
         BNE LB33A
LB331    CPY #$A0
         BCC LB33E
         LDY #$00
         INC L057A,X
LB33A    TYA
         STA L0566,X
LB33E    LDA L0552,X
         PHA
         LDA L057A,X
         TAX
         PLA
         JSR DRAW

         LDX ZP95
         LDA L0552,X
         BEQ LB35D
         INC L053E,X
         DEC L0566,X
         DEC L057A,X
         JMP LB382
LB35D    DEC L053E,X
         BPL LB37C
         LDA L058E,X
         AND #$7F
         TAY
         LDA #$00
         STA L0505,Y
         LDA L058E,X
         BMI LB37C
         LSR A
         LSR A
         LSR A
         STX ZP98
         TAX
         INC L00A5,X
         LDX ZP98
LB37C    INC L0566,X
         INC L057A,X
LB382    TXA
         CLC
         ADC #$0A
         TAX
         CPX #$14
         BCS LB38E
         JMP LB2F6
LB38E    RTS
;
; Draw "Bonus" text at the start of a level
;
DRW_BNS  PHA				; Draw 1xBonus on the screen
         LDA CURLEV
         AND #$FE
         CMP #$0B
         BCC LB39A			; < 11
         LDA #$0A
LB39A    TAY
         LDA BNS_LO,Y
         STA ZP8B
         LDA BNS_HI,Y
         STA ZP8C
         LDX #$28
         LDY #$29
         PLA
         PHA
         JSR DRAW			; Draw multiplier
         LDA #<BONUS
         STA ZP8B
         LDA #>BONUS
         STA ZP8C
         LDX #$28
         LDY #$34
         PLA
         JMP DRAW			; Draw "BONUS" text
;
; Process incoming missiles         
;
LB3BE    LDA L04DF,X		; Active missile
         BEQ LB407
         LDA L00A4
         CPX #$08
         BCS LB3CC
         LDA #$D0
         SEC
LB3CC    ADC L04CC,X
         STA L04CC,X
         BCC LB407
         DEC L04DF,X
         BNE LB3EC
         JSR LB764
         JSR LB8CA
         CPX #$08
         BCC LB407
         STX ZP95
         JSR LB829
         LDX ZP95
         BPL LB407
LB3EC    LDY L0480,X
         STX ZP98
         LDA #$55
         CPX #$08
         BCC LB3F9
         LDA #$AA
LB3F9    STA ZP8E
         LDA L0493,X
         TAX
         JSR DRW_MISS
         LDX ZP98
         JSR LB95B			; Move incoming missiles
LB407    DEX
         BPL LB3BE
         RTS
;
; Draw Base Routine
;
DRW_BASE LDA REM_BASE,X		; Draw Base Routine
         BNE ?L5
         JMP LB445
         
?L5      STX BASE_TMP
         DEC REM_BASE,X
         
         LDA #<BASEDAT		; Base image
         STA ZP8B
         LDA #>BASEDAT
         STA ZP8C
         
         CPX #$01
         BEQ ?BASE2
         CPX #$02
         BEQ ?BASE3

         LDX #$58			; y
         LDY #$2			; x
         LDA #$AA
         JSR DRAW			; Draw Base A
         
         LDA #<MISSDAT		; Missile image
         STA ZP8B
         LDA #>MISSDAT
         STA ZP8C

         LDY #$12
?L1      STY ZP95
         LDA BSA_POSY,Y
         TAX
         LDA BSA_POSX,Y
         TAY
         LDA #$55
         JSR DRAW			; Draw Missiles
         LDY ZP95
         DEY
         DEY
         BPL ?L1
         JMP ?L4

?BASE2
         LDX #$58			; y
         LDY #$49			; x
         LDA #$AA
         JSR DRAW			; Draw Base B

         LDA #<MISSDAT		; Missile image
         STA ZP8B
         LDA #>MISSDAT
         STA ZP8C

         LDY #$12
LB42C    STY ZP95
         LDA BSB_POSY,Y
         TAX
         LDA BSB_POSX,Y
         TAY
         LDA #$55
         JSR DRAW			; Draw Missiles
         LDY ZP95
         DEY
         DEY
         BPL LB42C
         JMP ?L4

?BASE3
         LDX #$58			; y
         LDY #$8D 			; x
         LDA #$AA
         JSR DRAW			; Draw Base C
         
         LDA #<MISSDAT		; Missile image
         STA ZP8B
         LDA #>MISSDAT
         STA ZP8C

         LDY #$12
?L2      STY ZP95
         LDA BSC_POSY,Y
         TAX
         LDA BSC_POSX,Y
         TAY
         LDA #$55
         JSR DRAW			; Draw Missiles
         LDY ZP95
         DEY
         DEY
         BPL ?L2

?L4      LDX BASE_TMP
         LDA #$0A			; 10 Missiles at base
         STA CUR_MS,X
LB445    RTS
;
; Draw cities, bases, and clear memory
;
INIT_GAME
         LDA #$00
         STA L00A1
         LDY #$07
LB44C    STA L00BC,Y		; Zero $BC-$C3
         DEY
         BPL LB44C
         STA ZPE7
         STA L00CF
         JSR CLR_MEM		; Clear Memory
         LDX #$12
LB45B    STA L04DF,X
         STA L0505,X
         DEX
         BPL LB45B
         STA L00A8
         LDX #$06
LB468    STA HPOSP1,X		; Clear Horizontal Positions
         DEX
         BPL LB468
         
         STA ZPC8
         STA ZPC9
         STA ZPCA
         LDX #$06
LB476    JSR CLR_SND		; Clear Sound?
         DEX
         DEX
         BPL LB476
         
         LDA #$AA
         LDX #$77
LB481    STA LAND_MEM,X		; Draw ground
         DEX
         BPL LB481
         
         LDA #$01
         STA REM_BASE		; 3 bases, each 10 missiles
         STA REM_BASE+1
         STA REM_BASE+2

         LDX #0
         STX BASE_CNT
?L6      JSR DRW_BASE		; Draw bases
         INC BASE_CNT
         LDX BASE_CNT
         CPX #$03
         BNE ?L6
         
         LDA #<CITYDAT		; Point to City Image
         STA ZP8B
         LDA #>CITYDAT
         STA ZP8C
         LDX #$05
LB498    STX ZP95			; Draw cities
         LDA CITIES,X
         BMI LB4AA
         LDY CITY_X,X		; x
         LDX #$59			; y
         LDA #$55
         JSR DRAW
         LDX ZP95
LB4AA    DEX
         BPL LB498
                         
         LDA #$08
         STA L00A6
         STA L00A5
         LDA #$03
         STA L00A7

         LDA ATR_AUTO
         BEQ ?INIT_B1
         LDA #$00
         BEQ ?INIT_B2
?INIT_B1 LDA ZPDA
         ASL A
         ADC ZPDA
         ASL A
?INIT_B2 TAX
         LDY #$05
LB4C0    LDA GAMECOLR,X		; PM color/color values
         STA L00D0,Y
         INX
         DEY
         BPL LB4C0
         
         LDA ATR_AUTO
         BEQ ?INIT_B3

         LDA #$05
         STA L00A2+2
         STA L00A2+1
         LDA #$00
         STA L00A2
         BEQ ?INIT_B4

?INIT_B3 LDA CURLEV
         ASL A
         ADC CURLEV
         TAX
         LDY #$02
LB4D2    LDA LBAB5,X		; Enemy count
         STA L00A2,Y
         INX
         DEY
         BPL LB4D2
?INIT_B4         
         LDA ATR_AUTO
         BEQ ?INIT_B5
         LDA #$00
         BEQ ?INIT_B6
?INIT_B5 LDA CURLEV
         LSR A
         STA ZP98
         ASL A
         ADC ZP98
?INIT_B6 TAX
         CPX #$13
         BCC LB4EB
         LDX #$12
LB4EB    LDY #$02
LB4ED    LDA LBAF4,X		; Level colors
         STA ZPD6,Y
         INX
         DEY
         BPL LB4ED
         
         LDA TKBFLAG
         BEQ LB502
         LDA L00A4
         CLC
         ADC #$0A
         STA L00A4
         
LB502    LDA SMRTFLAG		; option?
         BEQ LB511
         LDA ATR_AUTO
         BNE LB511
         CLC
         LDA L00A3
         ADC L00A2
         STA L00A2
         LDA #$00
         STA L00A3

LB511    LDA L00D3			; Set up colors
         STA COLOR4
         LDA L00D4
         STA COLOR1
         LDA L00D5
         STA COLOR0
         
         LDA L00D1			; Set up PM colors
         STA PCOLR0
         LDA L00D0
         STA PCOLR1
         STA PCOLR2
         STA PCOLR3
         
         LDA #$0A
         STA L00CF
         LDA #$FF
         LDX #$13
LB538    STA L053E,X
         DEX
         BPL LB538
         LDY B_CITIES
         CPY #$04
         BCC LB546
         LDY #$03
LB546    STY B_CITIES
         LDA #$04
         STA L00CB
         STA L00CC
         STA CUR_ON
LB550    RTS
;
; Clear memory starting at $1040
;
CLR_MEM  LDA #$00			
         LDY #$40
         STY ZP89
         LDY #$10		; $1040
         STY ZP8A
         LDX #$10
LB55D    LDY #$FF
LB55F    STA (ZP89),Y
         DEY
         BNE LB55F
         STA (ZP89),Y
         INC ZP8A
         DEX
         BNE LB55D
         RTS
;
; Sound for bonus screen
;
CNT_SND  STX TIMER1
         LDA #$00
         STA VBL_FLAG
         JSR C_SCORE
         LDA #$5B
         LDY #$60
         LDX #$00
         JSR DO_SND			; Missile/City Points Sound
         LDX TIMER1
LB580    STX TIMER1
LB582    LDA TIMER1
         BNE LB582
         RTS
;
; Print current score
;
C_SCORE  LDA VBL_FLAG
         BNE LB595
         LDX CURPLR
         LDA PLRIND,X
         LDX #$DC			; Player score = $DC-$DE
         JSR PSCORE			; Print Player Score
LB595    LDA VBL_FLAG
         BEQ LB595
         RTS
;
; Print Score
;
; A=index to screen memory
; X=index to memory with score to print
;
PSCORE
		 STA ZP98			; Display Score Routine
         LDA #$02			; 6 digits
         STA ZP99
LB5A0    LDA L0000,X
         TAY
         AND #$0F
         PHA				; Save LO
         TYA
         LSR A
         LSR A
         LSR A
         LSR A
         PHA				; Save HI
         INX
         DEC ZP99
         BPL LB5A0

         LDX #$F0
         LDY ZP98
         LDA #$05
         STA ZP99
LB5B9    PLA				; Get score byte
         BNE LB5C3
         LDA ZP99
         BEQ LB5C5
         TXA
         BNE LB5C5
LB5C3    LDX #$00
LB5C5    CLC
         ADC #$50			; ATASCII char
         STA TXT_MEM,Y
         INY
         DEC ZP99
         BPL LB5B9
         RTS

PSCORE2
		 STA ZP98			; Display Score Routine
         LDA #$02			; 6 digits
         STA ZP99
?LB5A0   LDA L0000,X
         TAY
         AND #$0F
         PHA				; Save LO
         TYA
         LSR A
         LSR A
         LSR A
         LSR A
         PHA				; Save HI
         INX
         DEC ZP99
         BPL ?LB5A0

         LDX #$F0
         LDY ZP98
         LDA #$05
         STA ZP99
?LB5B9   PLA				; Get score byte
         BNE ?LB5C3
         LDA ZP99
         BEQ ?LB5C5
         TXA
         BNE ?LB5C5
?LB5C3   LDX #$00
?LB5C5   CLC
         ADC #$50			; ATASCII char
         STA $F00+41,Y
         INY
         DEC ZP99
         BPL ?LB5B9
         RTS

;
; Process cursor
;         
CURSOR   LDA ATR_MODE
         BNE ?CUR_STR
         JMP ?DO_CUR
?CUR_STR
         LDA ATR_IDX
         BNE ?CUR_BR2
   
?CUR_NEW LDX #$07
?CUR_LP1 LDA L04E7,X
         BNE ?CUR_BR1
         DEX
         BPL ?CUR_LP1
         LDA L00A9
         BEQ ?CUR_NO
         
         LDA L00AB		; Look for Bomber
         STA L049B
         LDA L00AA
         LDX L00A9
         BMI ?CUR_SB
         SEC
         SBC #$20
         JMP ?CUR_SV
?CUR_SB  SEC
         SBC #$40
?CUR_SV  STA L0488
         LDX #0	
         JMP ?CUR_SP
         
?CUR_NO  LDA #$0F
         STA ATR_JOY
         JMP ?DO_CUR
         
?CUR_BR1 STX ATR_IDX
?CUR_BR2
         LDA TIMER2
         BNE ?CUR_NO
         
         LDX ATR_IDX
         LDA L04E7,X
         BEQ ?CUR_NEW
?CUR_SP
         LDA CURSOR_X
         SEC
         SBC #$2E
         SBC L0488,X
         BCS ?MV_LEFT
         LDY #$07
         BNE ?MV_UP
?MV_LEFT LDY #$11
?MV_UP   STY ATR_JOY
         STA ATR_DIS
         
         LDA CURSOR_Y
         SEC
         SBC #$04
         SBC L049B,X
         BCC ?MV_DWN
         LDY #$0E
         BNE ?MV_DIR
?MV_DWN  LDY #$0D
?MV_DIR  CLC
         ADC ATR_DIS
         STA ATR_DIS
         TYA
         AND ATR_JOY
         STA ATR_JOY
         LDA ATR_DIS
         CMP #$04
         BCS ?MV_NF
         LDA ATR_FIRE
         BNE ?MV_NF
         LDA #$01
         STA ATR_FIRE
         LDA #$03
         STA TIMER2
?MV_NF   JMP ?MV_CUR

 .IF ATARI_8
;--------------------------------------
; Atari 800
;--------------------------------------
         
?DO_CUR  LDA TKBFLAG
         BEQ LB5E9
         CLC
         LDA CURSOR_X
         ADC ZPEC
         TAX
         CLC
         LDA CURSOR_Y
         ADC ZPED
         TAY
         LDA #$00
         STA ZPEC
         STA ZPED
         BEQ LB624

LB5E9    LDX CURPLR
?MV_CUR
         JSR GETJOY
         LDX CURSOR_X
         LDY CURSOR_Y
         LSR A
         BCC LB605
         LSR A
         BCC LB60D
LB5F8    LSR A
         BCC LB61E
         LSR A
         BCS LB624
         LDA CURSOR_X
         ADC #$01
         JMP LB623
LB605    SEC
         LDA CURSOR_Y
         SBC #$01
         JMP LB611
LB60D    LDA CURSOR_Y
         ADC #$01
LB611    TAY
         LDX CURPLR
         JSR GETJOY
         LDX CURSOR_X
         LSR A
         LSR A
         JMP LB5F8
LB61E    SEC
         LDA CURSOR_X
         SBC #$01
LB623    TAX
LB624    TYA

 .ELSE
;--------------------------------------
; Atari 5200
;--------------------------------------

?DO_CUR  LDA TKBFLAG
         BEQ LB5E9
         CLC
         LDA CURSOR_X
         ADC ZPEC
         TAX
         CLC
         LDA CURSOR_Y
         ADC ZPED
         TAY
         LDA #$00
         STA ZPEC
         STA ZPED
         BEQ LB624

LB5E9    LDX CURPLR
?MV_CUR  LDA ATR_MODE
         BEQ ?DO_CUR2
         LDA ATR_JOY
         LDX CURSOR_X
         LDY CURSOR_Y
         LSR A
         BCC LB605
         LSR A
         BCC LB60D
LB5F8    LSR A
         BCC LB61E
         LSR A
         BCS LB624
         LDA CURSOR_X
         ADC #$01
         JMP LB623
LB605    SEC
         LDA CURSOR_Y
         SBC #$01
         JMP LB611
LB60D    LDA CURSOR_Y
         ADC #$01
LB611    TAY
         LDA ATR_JOY
         LDX CURSOR_X
         LSR A
         LSR A
         JMP LB5F8
LB61E    SEC
         LDA CURSOR_X
         SBC #$01
         JMP LB623
?DO_CUR2
         LDA PADDL0,X
         PHA
         INX
         LDA PADDL0,X
         TAY
         PLA
LB623    TAX
LB624    TYA

 .ENDIF
;--------------------------------------

         BMI LB62B
         CMP #$08			; Min left position 
         BCS LB62D
LB62B    LDA #$08
LB62D    CMP #$4F			; Max right position
         BCC LB633
         LDA #$4F
LB633    TAY
         CPX #$2F			; Min top position
         BCS LB63A
         LDX #$2F
LB63A    CPX #$C9			; Min bottom position
         BCC LB640
         LDX #$C9
LB640    STX HPOSP0
         STX CURSOR_X		; cursor position
         STY CURSOR_Y
;         LDA REM_BASE		; Different cursor if no more cities
;         BNE LB655
;         LDA #<LBBDB		; $BBDB
;         STA ZP8B
;         LDA #>LBBDB
;         STA ZP8C
;         BNE LB65D
LB655    LDA #<LBBD8		; $BBD8
         STA ZP8B
         LDA #>LBBD8
         STA ZP8C
LB65D    LDA #$02			; Length
         LDX #$00			; Buffer 0
         JMP DRAW2

GETJOY   LDA ATR_MODE
         BEQ ?N_JOY
         LDA ATR_JOY
         RTS
?N_JOY
         LDA STICK0,X
         RTS
;
; Draw image
;
DRAW
         STA ZP8E
         CPX #$61
         BCS LB671
         TXA
         ASL A
         TAX
         CPY #$A0
         BCC LB672
LB671    ; BRK
         NOP
LB672    TYA
         LSR A
         LSR A
         CLC
         ADC L08C0,X
         STA ZP89
         LDA L08C1,X
         ADC #$00
         STA ZP8A
         TYA
         AND #$03
         ASL A
         STA ZP8F
         LDY #$00
         LDA (ZP8B),Y
         STA ZP9A
         INY
         LDA (ZP8B),Y
         STA ZP8D
         INY
         STY ZP90
LB696    LDY #$FF
         STY ZP98
         INY
LB69B    LDA #$FF
         STA ZP99
         STY ZP91
         LDY ZP90
         LDA (ZP8B),Y
         INC ZP90
         LDY ZP91
         LDX ZP8F
         BEQ LB6B4
LB6AD    SEC
         ROR A
         ROR ZP99
         DEX
         BNE LB6AD
LB6B4    AND ZP98
         TAX
         AND (ZP89),Y
         STA (ZP89),Y
         TXA
         EOR #$FF
         AND ZP8E
         ORA (ZP89),Y
         STA (ZP89),Y
         LDA ZP99
         STA ZP98
         INY
         CPY ZP8D
         BNE LB69B
         DEC ZP9A
         BEQ LB6DF
         LDA ZP89
         CLC
         ADC #$28
         STA ZP89
         BCC LB696
         INC ZP8A
         JMP LB696
LB6DF    RTS
;
; Draw2 - Draw plane/bomber/smart bomb/cursor
;
; A=98
; Y=99
; X=buffer
;
DRAW2    STA ZP98
         STY ZP99
         TXA
         ASL A
         TAX
         LDA DW_BUFLO,X		; Zero buffer for image
         STA ZP89
         LDA DW_BUFHI,X
         STA ZP8A
         LDA #$00
         LDY #$7F
LB6F5    STA (ZP89),Y
         DEY
         BPL LB6F5
         
         CLC
         LDA ZP99			; Copy image to buffer
         ADC ZP89
         STA ZP89
         BCC LB705
         INC ZP8A
LB705    LDY ZP98
LB707    LDA (ZP8B),Y
         STA (ZP89),Y
         DEY
         BPL LB707
         
         RTS
;
; Draw incoming missile
;      
DRW_MISS CPX #$60
         BCS LB71A
         TXA
         ASL A
         TAX
         CPY #$A0
         BCC LB71B
LB71A    ; BRK
         NOP
LB71B    LDA L08C0,X
         STA ZP89
         LDA L08C1,X
         STA ZP8A
         TYA
         AND #$03
         TAX
         TYA
         LSR A
         LSR A
         TAY
         LDA LB73F,X
         TAX
         AND (ZP89),Y
         STA ZP9B
         TXA
         EOR #$FF
         AND ZP8E
         ORA ZP9B
         STA (ZP89),Y
         RTS
         
LB73F    .BYTE $3F,$CF,$F3,$FC
;
; Y coordinate processing
;
LB743    LDA L052B,X
         BPL LB759
LB748    CPX #$08
         BCS LB750
         DEC L0493,X
         RTS
LB750    INC L0493,X
         RTS
;
; X coordinate processing
;
LB754    LDA L052B,X
         BPL LB748
LB759    LSR A
         BCC LB760
         INC L0480,X
         RTS
LB760    DEC L0480,X
         RTS
;
;
;         
LB764    LDA L0505,X
         STA L04DF,X
LB76A    LDA #$00
         STA ZP8E
         LDA L04A6,X
         STA L0480,X
         LDA L04B9,X
         STA L0493,X
         LDA #$00
         STA L04F2,X
LB77F    LDY L0480,X
         LDA L0493,X
         STX ZP98
         TAX
         JSR DRW_MISS
         LDX ZP98
         CLC
         LDA L04F2,X
         ADC L0518,X
         STA L04F2,X
         CMP L0505,X
         BCC LB7A7
         BEQ LB7A7
         SBC L0505,X
         STA L04F2,X
         JSR LB743
LB7A7    JSR LB754
         DEC L04DF,X
         BNE LB77F
         RTS
;
; Erase current missile from base
;
ERASE_MS LDA CUR_MS,X
         ASL A
         TAY
         CPX #$00
         BNE E_MS1
         LDA BSA_POSY,Y
         TAX
         LDA BSA_POSX,Y
         TAY
         JMP E_MS
         
E_MS1    CPX #$01
         BNE E_MS2
         LDA BSB_POSY,Y
         TAX
         LDA BSB_POSX,Y
         TAY
         JMP E_MS

E_MS2    LDA BSC_POSY,Y
         TAX
         LDA BSC_POSX,Y
         TAY

E_MS     LDA #<MISSDAT		; Missile image
         STA ZP8B
         LDA #>MISSDAT
         STA ZP8C
         LDA #$AA
         JMP DRAW
;
; Target a city/base randomly???
;
LB7C9    LDA RANDOM			; Random number
         AND #$0F
         LDX B_CITIES
         BEQ LB7FA			; No cities to target
LB7D2    CMP #$06
         BCC LB7DA			; < 6 then branch
         SBC #$06
         BCS LB7D2			; Otherwise subtract 6 till < 6
LB7DA    TAX
         BIT RANDOM
LB7DE    LDA CITIES,X		; Does city still exist?
         BEQ LB7F4
         BVC LB7ED			; Yes
         INX
         CPX #$06
         BCC LB7DE			; Try another city
         LDX #$00
         BEQ LB7DE
LB7ED    DEX
         BPL LB7DE
         LDX #$05
         BNE LB7DE
LB7F4    INC CITIES,X
         DEC B_CITIES
         BPL LB81E

LB7FA    LDX ZPE7			; Target a base
         BNE LB802
?RDM     LDA RANDOM
         AND #$03
         CMP #$03
         BEQ ?RDM
         CLC
         ADC #$06
         TAX         
;         LDX #$06
         BNE LB818
LB802    CMP #$07
         BCC LB80A
         SBC #$07
         BCS LB802
LB80A    TAX
         CPX #$06
         BEQ LB818
         LDA CITIES,X
         BNE LB818
         TXA
         ADC #$04
         BCC LB802
LB818    LDA CITIES,X
         BMI LB81E
         INC CITIES,X
LB81E    LDA X_POS,X		; X coordinate of city/base
         RTS

;
; X coordinates of cities/base
;
X_POS
        .BYTE $1B ; $13
		.BYTE $2C ; $26
		.BYTE $3D ; $3A
        .BYTE $62 ; $67
        .BYTE $72 ; $7A
		.BYTE $82 ; $8C
		.BYTE $09 ; base A
		.BYTE $50 ; base B
		.BYTE $94 ; base C
;
LB829    LDA L00A9,X
         CMP #$09 ; 07
         BCC LB830
;         BRK
         NOP
         
;LB829	.BYTE $B5
;		.BYTE $A9
;		.BYTE $C9
;       .BYTE $07
;		.BYTE $90
;		.BYTE $01
;		.BYTE $00

LB830    CMP #$06			; Base hit
         BCC LB849
         SEC
         SBC #$06
         STA BASE_IDX
;         BNE LB849
LB834    LDX BASE_IDX
         LDA CUR_MS,X
         BEQ LB842
;         CMP #$04
;         BCC LB842
         DEC CUR_MS,X
         JSR ERASE_MS
         JMP LB834
LB842    DEC ZPE7
         LDA #$00
         LDX BASE_IDX
         STA CUR_MS,X
         RTS
LB849    TAX
         LDA #$FF
         STA CITIES,X
         RTS
         
LB84F    LDY #$0F
LB851    LDA L0505,Y
         BEQ LB85C
         DEY
         CPY #$07
         BNE LB851
         ; BRK
         NOP
LB85C    TXA
         STA L00A9,Y
         DEC L00A3
         DEC L00CB
         DEC L00A6
         LDA X_POS,X
         STA L00AF
         LDA #$57
         STA L00B0
;
; Calc. slope line
;
LB86F    LDA L00AD			; Start X
         STA L04A6,Y
         STA L0480,Y
         LDA L00AE			; Start Y
         STA L04B9,Y
         STA L0493,Y
         SEC
         SBC L00B0			; Subtract end Y
         BCS LB888
         EOR #$FF
         ADC #$01
LB888    STA ZPDB			; save dY
         SEC
         LDA L00AF			; End X
         SBC L00AD			; Subtract start X
         BCS LB89A
         EOR #$FF
         ADC #$01
         TAX
         LDA #$00
         BEQ LB89D
LB89A    TAX
         LDA #$01
LB89D    STA L052B,Y		; save dX
         TXA
         CMP ZPDB
         BCS LB8AA
         TAX
         LDA ZPDB
         BCC LB8B6
LB8AA    TAX
         LDA #$80
         ORA L052B,Y
         STA L052B,Y
         TXA
         LDX ZPDB
LB8B6    STA L0505,Y
         STA L04DF,Y
         INX
         TXA
         STA L0518,Y
         LDA #$00
         STA L04F2,Y
         STA L04CC,Y
         RTS
         
LB8CA    LDA L0480,X
         STA L00AF
         LDA L0493,X
         STA L00B0
LB8D4    STX ZP98
         LDA #$0B
         LDY #$10
         LDX #$00
         JSR DO_SND			; Sound
         LDA #$15
         LDY #$1A
         LDX #$02
         JSR DO_SND			; Sound
LATTR
         LDY ZP98
         CPY #$18
         BCC LB8FD
         LDA ZPEE
         BNE LB8F7
         LDX #$06
         JSR CLR_SND
LB8F7    LDY #$10
         LDA #$80
         BMI LB920
LB8FD    CPY #$10
         BCC LB91E
         DEC ZPEE
         BNE LB91E
         STY ZP99
         LDA L00A8
         BEQ LB917
         LDA #$6F
         LDY #$74
         LDX #$06
         JSR DO_SND			; Sound
         JMP LB91C
LB917    LDX #$06
         JSR CLR_SND
LB91C    LDY ZP99
LB91E    LDA #$00
LB920    LDX L053E,Y
         BMI LB926
         ; BRK
         NOP
LB926    STY ZP99
         ORA ZP99
         STA L058E,Y
         LDA L00AF
         STA L0566,Y
         LDA L00B0
         STA L057A,Y
         LDA #$00
         STA L053E,Y
         LDA #$FF
         STA L0552,Y
         LDX ZP98
         RTS

LB944    CMP #$06
         BEQ LB958
         TAY
         LDA CITIES,Y
         BMI LB957
         SBC #$00
         BNE LB954
         INC B_CITIES
LB954    STA CITIES,Y
LB957    RTS
LB958    DEC ZPE7
         RTS

LB95B    LDA L04F2,X
         CLC
         ADC L0518,X
         STA L04F2,X
         CMP L0505,X
         BCC LB975
         BEQ LB975
         SBC L0505,X
         STA L04F2,X
         JSR LB743
LB975    JMP LB754
;
; Add to current score
;
; 98=lo value to add
; 99=hi value to add
;
ADDSCR   PHA
         LDA ATR_MODE
         BEQ ?ADD_B1
         PLA
         RTS
?ADD_B1  PLA
         STA ZP98			; Add score routine
         LDA CURLEV
         LSR A
         CMP #$06
         BCC LB983
         LDA #$05
LB983    STA ZP9A			; Current Bonus
         SED
LB986    CLC
         LDA ZP98
         ADC P1_SCORE
         STA P1_SCORE
         LDA ZP99
         ADC P1_SCORE+1
         STA P1_SCORE+1
         LDA #$00
         ADC P1_SCORE+2
         STA P1_SCORE+2
         BCC LB99D
         STA BONUSVAR
LB99D    DEC ZP9A
         BPL LB986
         CLD
         RTS
;
; Routines for sound processing
;
CLR_SND  LDA #$00			; Sound Process?
         TAY
DO_SND   PHA
         LDA ATR_MODE
         BNE ?NO_SND
         PLA
         INC SND_FLAG
         STA L05C2,X
         TYA
         STA L05C3,X
         LDA #$01
         STA L05CA,X
         STA L05CB,X
         STA L05BA,X
         STA L05BB,X
         DEC SND_FLAG
         RTS
?NO_SND
         PLA
         RTS
;
;
;
CHK_OPT
         LDA SMRTFLAG
         BEQ ?NORMAL
         LDA #$0A
         STA STXT_MEM
?NORMAL
         LDX #$03
         LDA TKBFLAG
         BEQ ?NOTKB

?TBK     LDA TKB_TXT,X
         STA TTXT_MEM,X
         DEX
         BPL ?TBK
         BMI ?LEV       

?NOTKB   LDA STK_TXT,X
         STA TTXT_MEM,X
         DEX
         BPL ?NOTKB
?LEV
         RTS         
;
; Fill memory starting at $1040
;
FILL_MEM LDA #~01010101			
         LDY #$40
         STY ZP89
         LDY #$10		; $1040
         STY ZP8A
         LDX #$10
?LB55D   LDY #$FF
?LB55F   STA (ZP89),Y
         DEY
         BNE ?LB55F
         STA (ZP89),Y
         INC ZP8A
         DEX
         BNE ?LB55D
         RTS

;--------------------------------------
;
; *=$B500
;
; Misc Data
;

END_OPN1
		.BYTE 20	; Rows
		.BYTE $0C	; Width

		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11110000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111100,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11110000,~00000000,~11111111,~11111111,~00001111,~00000000,~11110000,~11111111,~11111111,~00000000
		.BYTE ~11111111,~11111111,~11000000,~00000000,~11111111,~11111111,~00001111,~00000000,~11110000,~11111111,~11111111,~00000000
		.BYTE ~11111111,~11111100,~00000000,~00000000,~00000011,~11000000,~00001111,~00000000,~11110000,~11110000,~00000000,~00000000
		.BYTE ~11111111,~11110000,~00000000,~00000000,~00000011,~11000000,~00001111,~00000000,~11110000,~11110000,~00000000,~00000000
		.BYTE ~11111111,~00000000,~00000000,~00000000,~00000011,~11000000,~00001111,~00000000,~11110000,~11110000,~00000000,~00000000
		.BYTE ~11111100,~00000000,~00000000,~00000000,~00000011,~11000000,~00001111,~00000000,~11110000,~11110000,~00000000,~00000000
		.BYTE ~11110000,~00000000,~00000000,~00000000,~00000011,~11000000,~00001111,~11111111,~11110000,~11111111,~11110000,~00000000

END_OPN2
		.BYTE 20	; Rows
		.BYTE $0C	; Width
		.BYTE ~11110000,~00000000,~00000000,~00000000,~00000011,~11000000,~00001111,~11111111,~11110000,~11111111,~11110000,~00000000
		.BYTE ~11111100,~00000000,~00000000,~00000000,~00000011,~11000000,~00001111,~00000000,~11110000,~11110000,~00000000,~00000000
		.BYTE ~11111111,~00000000,~00000000,~00000000,~00000011,~11000000,~00001111,~00000000,~11110000,~11110000,~00000000,~00000000
		.BYTE ~11111111,~11110000,~00000000,~00000000,~00000011,~11000000,~00001111,~00000000,~11110000,~11110000,~00000000,~00000000
		.BYTE ~11111111,~11111100,~00000000,~00000000,~00000011,~11000000,~00001111,~00000000,~11110000,~11110000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11000000,~00000000,~00000011,~11000000,~00001111,~00000000,~11110000,~11111111,~11111111,~00000000
		.BYTE ~11111111,~11111111,~11110000,~00000000,~00000011,~11000000,~00001111,~00000000,~11110000,~11111111,~11111111,~00000000
		.BYTE ~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111100,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11110000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~00000000
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111

END_OPN3
		.BYTE 20	; Rows
		.BYTE $0C	; Width

		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00001111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000011,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111
		.BYTE ~00000000,~11111111,~11111111,~00001111,~00000000,~11110000,~11111111,~11110000,~00000000,~00001111,~11111111,~11111111
		.BYTE ~00000000,~11111111,~11111111,~00001111,~00000000,~11110000,~11111111,~11110000,~00000000,~00000011,~11111111,~11111111
		.BYTE ~00000000,~11110000,~00000000,~00001111,~00000000,~11110000,~11110000,~00001111,~00000000,~00000000,~00111111,~11111111
		.BYTE ~00000000,~11110000,~00000000,~00001111,~11000000,~11110000,~11110000,~00001111,~00000000,~00000000,~00001111,~11111111
		.BYTE ~00000000,~11110000,~00000000,~00001111,~11000000,~11110000,~11110000,~00001111,~00000000,~00000000,~00000000,~11111111
		.BYTE ~00000000,~11110000,~00000000,~00001111,~00110000,~11110000,~11110000,~00001111,~00000000,~00000000,~00000000,~00111111
		.BYTE ~00000000,~11111111,~11110000,~00001111,~00110000,~11110000,~11110000,~00001111,~00000000,~00000000,~00000000,~00001111

END_OPN4
		.BYTE 20	; Rows
		.BYTE $0C	; Width
		.BYTE ~00000000,~11111111,~11110000,~00001111,~00001100,~11110000,~11110000,~00001111,~00000000,~00000000,~00000000,~00001111
		.BYTE ~00000000,~11110000,~00000000,~00001111,~00001100,~11110000,~11110000,~00001111,~00000000,~00000000,~00000000,~00111111
		.BYTE ~00000000,~11110000,~00000000,~00001111,~00000011,~11110000,~11110000,~00001111,~00000000,~00000000,~00000000,~11111111
		.BYTE ~00000000,~11110000,~00000000,~00001111,~00000011,~11110000,~11110000,~00001111,~00000000,~00000000,~00001111,~11111111
		.BYTE ~00000000,~11110000,~00000000,~00001111,~00000000,~11110000,~11110000,~00001111,~00000000,~00000000,~00111111,~11111111
		.BYTE ~00000000,~11111111,~11111111,~00001111,~00000000,~11110000,~11111111,~11110000,~00000000,~00000011,~11111111,~11111111
		.BYTE ~00000000,~11111111,~11111111,~00001111,~00000000,~11110000,~11111111,~11110000,~00000000,~00001111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000011,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00001111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~00000000,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111
		.BYTE ~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111,~11111111


BNSCITY
		.BYTE $62		; BONUS CITY
		.BYTE $6F
		.BYTE $6E
		.BYTE $75
		.BYTE $73
		.BYTE $00
		.BYTE $63
		.BYTE $69
		.BYTE $74
		.BYTE $79

OUT_TXT .BYTE $5
        .BYTE $4
      
        .BYTE ~11111111,~11111111,~11111111,~11111111
        .BYTE ~11000000,~11001100,~11000000,~11111111
        .BYTE ~11001100,~11001100,~11110011,~11111111
        .BYTE ~11000000,~11000000,~11110011,~11111111
        .BYTE ~11111111,~11111111,~11111111,~11111111
        
LOW_TXT .BYTE $5
        .BYTE $4

        .BYTE ~11111111,~11111111,~11111111,~11111111
        .BYTE ~11001111,~00000011,~00110011,~00111111
        .BYTE ~11001111,~00110011,~00110011,~00111111
        .BYTE ~11000011,~00000011,~00000000,~00111111
        .BYTE ~11111111,~11111111,~11111111,~11111111
       

BNS_TXT .BYTE $22		; BONUS
        .BYTE $2F
        .BYTE $2E
        .BYTE $35
        .BYTE $33
        .BYTE $00
        .BYTE $23		; CITY
        .BYTE $29
        .BYTE $34
        .BYTE $39
        .BYTE $00
        .BYTE $25		; EVERY
        .BYTE $36
        .BYTE $25
        .BYTE $32
        .BYTE $39
        .BYTE $00
        .BYTE $00
        .BYTE $00
        .BYTE $00
        .BYTE $00
        .BYTE $00
        .BYTE $51		; 10000
        .BYTE $50
        .BYTE $50
        .BYTE $50
        .BYTE $50
        .BYTE $00
        .BYTE $30		; POINTS
        .BYTE $2F
        .BYTE $29
        .BYTE $2E
        .BYTE $34
        .BYTE $33

        
HS_TXT  .BYTE $28		; HIGH 
		.BYTE $29
		.BYTE $27
		.BYTE $28
		.BYTE $00
		.BYTE $33
		.BYTE $23		; SCORE
		.BYTE $2F
		.BYTE $32
		.BYTE $25

DEF_TXT	.BYTE $24		; Defend
		.BYTE $25
		.BYTE $26
		.BYTE $25
		.BYTE $2E
		.BYTE $24
		.BYTE $00
		.BYTE $00
		.BYTE $23
		.BYTE $29		; Cities
		.BYTE $34
		.BYTE $29
		.BYTE $25
		.BYTE $33

ARROW_X .BYTE $1A
		.BYTE $2B
		.BYTE $3C
		.BYTE $61
		.BYTE $71
		.BYTE $81
        
ARROW   .BYTE $05
        .BYTE $03
        
        .BYTE ~11110000
        .BYTE ~11111111
        .BYTE ~11111111

        .BYTE ~11110000
        .BYTE ~11111111
        .BYTE ~11111111

        .BYTE ~00110000
        .BYTE ~11001111
        .BYTE ~11111111

        .BYTE ~11000000
        .BYTE ~00111111
        .BYTE ~11111111
        
        .BYTE ~11110000
        .BYTE ~11111111
        .BYTE ~11111111
         
MISSTXT
		.BYTE $00
		.BYTE $00
		.BYTE $2D		; Missile
		.BYTE $29
		.BYTE $33
		.BYTE $33
		.BYTE $29
		.BYTE $2C
		.BYTE $25
		.BYTE $00
		.BYTE $23		; Command
		.BYTE $2F
		.BYTE $2D
		.BYTE $2D
		.BYTE $21
		.BYTE $2E
		.BYTE $24
		.BYTE $0B
		.BYTE $00
		.BYTE $00
        
		.BYTE $00
		.BYTE $08		; (C)
		.BYTE $23
		.BYTE $09
		.BYTE $00
		.BYTE $12		; 2004
		.BYTE $10
		.BYTE $10
		.BYTE $16
		.BYTE $00
		.BYTE $30		; Paul
		.BYTE $21
		.BYTE $35
		.BYTE $2C
		.BYTE $00
		.BYTE $2C		; Lee
		.BYTE $25
		.BYTE $25
		.BYTE $00
		.BYTE $00

		.BYTE $30		; 1P
		.BYTE $00
		.BYTE $00
		.BYTE $2C		; LEVEL
		.BYTE $25
		.BYTE $36
		.BYTE $25
		.BYTE $2C
		.BYTE $00
		.BYTE $00
		.BYTE $33		; STIK/TBAL
		.BYTE $34
		.BYTE $29
		.BYTE $2B
		.BYTE $00
		.BYTE $22		; BONUS
		.BYTE $2F
		.BYTE $2E
		.BYTE $35
		.BYTE $33

TKB_TXT .BYTE $34,$22,$21,$2C
STK_TXT .BYTE $33,$34,$29,$2B

PLRIND	.BYTE $15		; Player 1 index to memory to print score
		.BYTE $21		; Player 2 

PCURNT
		.BYTE $1B		; Player 1 index to memory to print "<"
		.BYTE $27		; Player 2
;
; Sound Data
;
SND_DATA
		.BYTE $00		; 0
		.BYTE $10
		.BYTE $01
		.BYTE $02
		.BYTE $20
		.BYTE $01
		
		.BYTE $A4		; 1
		.BYTE $00
		.BYTE $02
		.BYTE $20
		.BYTE $06
		.BYTE $A0
		
		.BYTE $04		; 2
		.BYTE $10
		.BYTE $10
		.BYTE $00
		.BYTE $86
		.BYTE $FE
		
		.BYTE $40		; 3
		.BYTE $04
		.BYTE $00
		.BYTE $C0
		.BYTE $04
		.BYTE $10

		.BYTE $10		; 4
		.BYTE $00
		.BYTE $86
		.BYTE $FE
		.BYTE $40
		.BYTE $04
		
		.BYTE $00		; 5
		.BYTE $18
		.BYTE $FF
		.BYTE $02
		.BYTE $10
		.BYTE $24
		
		.BYTE $08		; 6
		.BYTE $00
		.BYTE $20
		.BYTE $01
		.BYTE $00
		.BYTE $A4
		
		.BYTE $FF		; 7
		.BYTE $10
		.BYTE $04
		.BYTE $00
		.BYTE $40
		.BYTE $00

		.BYTE $10		; 8
		.BYTE $01
		.BYTE $33
		.BYTE $36
		.BYTE $FA
		.BYTE $10
		
		.BYTE $01		; 9
		.BYTE $38
		.BYTE $30
		.BYTE $0B
		.BYTE $10
		.BYTE $01
		
		.BYTE $3D		; 10
		.BYTE $40
		.BYTE $F5
		.BYTE $18
		.BYTE $01
		.BYTE $42
		
		.BYTE $40		; 11
		.BYTE $FA
		.BYTE $10
		.BYTE $01
		.BYTE $47
		.BYTE $40

		.BYTE $06		; 12
		.BYTE $10
		.BYTE $10
		.BYTE $00
		.BYTE $82
		.BYTE $02
		
		.BYTE $20		; 13
		.BYTE $01
		.BYTE $51
		.BYTE $84
		.BYTE $00
		.BYTE $10
		
		.BYTE $04		; 14
		.BYTE $56
		.BYTE $84
		.BYTE $FF
		.BYTE $38
		.BYTE $04

		.BYTE $00		; 15
		.BYTE $10
		.BYTE $00
		.BYTE $04
		.BYTE $01
		.BYTE $00

		.BYTE $2F		; 16
		.BYTE $0F
		.BYTE $04
		.BYTE $01
		.BYTE $00
		.BYTE $30

		.BYTE $FE		; 17
		.BYTE $01
		.BYTE $18
		.BYTE $65
		.BYTE $A4
		.BYTE $00
		
		.BYTE $01		; 18
		.BYTE $18
		.BYTE $6A
		.BYTE $50
		.BYTE $FE
		.BYTE $01
		
		.BYTE $20		; 19
		.BYTE $6F
		.BYTE $A4
		.BYTE $00
		.BYTE $01
		.BYTE $20

		.BYTE $74
;
; PM colors/colors
;
; 0 = PCOLR1-3
; 1 = PCOLR0
; 2 = COLPF1
; 3 = COLOR4
; 4 = COLOR1
; 5 = COLOR0
;
GAMECOLR
		.BYTE $84		; Lev 0
		.BYTE $34
		.BYTE $00
		.BYTE $1A
		.BYTE $0F
    	.BYTE $C4

		.BYTE $84		; Lev 1
		.BYTE $C4
		.BYTE $00
		.BYTE $1A
		.BYTE $0F
		.BYTE $34

		.BYTE $D8		; Lev 2
		.BYTE $34
		.BYTE $00
		.BYTE $84
		.BYTE $0F
		.BYTE $48

		.BYTE $88		; Lev 3
		.BYTE $1A
		.BYTE $00
		.BYTE $34
		.BYTE $0F
		.BYTE $C4

		.BYTE $00		; Lev 4
		.BYTE $48
		.BYTE $84
		.BYTE $1A
		.BYTE $0F
		.BYTE $38
		
		.BYTE $84		; Lev 5
		.BYTE $3C
		.BYTE $8E
		.BYTE $1A
		.BYTE $00
		.BYTE $1C

		.BYTE $1C		; Lev 6
		.BYTE $00
		.BYTE $6E
		.BYTE $C4
		.BYTE $38
		.BYTE $48

		.BYTE $3A		; Lev 7
		.BYTE $00
		.BYTE $1C
		.BYTE $C4
		.BYTE $84
		.BYTE $88

		.BYTE $68		; Lev 8
		.BYTE $DA
		.BYTE $0C
		.BYTE $34
		.BYTE $00
		.BYTE $1A

		.BYTE $88		; Lev 9
		.BYTE $00
		.BYTE $34
		.BYTE $1A
		.BYTE $0F
		.BYTE $2A
;
; Number of emeny per level???
;
; 0 =
; 1 = # of incoming missiles
; 2 = # of smart bombs
;      
LBAB5
     	.BYTE $10		; Lev 0
		.BYTE $08
		.BYTE $00

		.BYTE $15		; Lev 1
		.BYTE $0C
		.BYTE $00
		
		.BYTE $1A		; Lev 2
		.BYTE $0F
		.BYTE $00
		
		.BYTE $20		; Lev 3
		.BYTE $12
		.BYTE $00

		.BYTE $26		; Lev 4
		.BYTE $0C
		.BYTE $00

		.BYTE $28		; Lev 5
		.BYTE $10
		.BYTE $01

		.BYTE $2A		; Lev 6
		.BYTE $0E
		.BYTE $01

		.BYTE $2B		; Lev 7
		.BYTE $11
		.BYTE $02

		.BYTE $2D		; Lev 8
		.BYTE $0A
		.BYTE $03

		.BYTE $2F		; Lev 9
		.BYTE $0D
		.BYTE $04

		.BYTE $34		; Lev 10
		.BYTE $10
		.BYTE $04

		.BYTE $38		; Lev 11
		.BYTE $13
		.BYTE $05

		.BYTE $3D		; Lev 12
    	.BYTE $0C
		.BYTE $05
		
		.BYTE $41		; Lev 13
		.BYTE $0E
		.BYTE $06
		
		.BYTE $44		; Lev 14
		.BYTE $10
		.BYTE $06
		
		.BYTE $48		; Lev 15
		.BYTE $12
		.BYTE $07
		
		.BYTE $4A		; Lev 16?
		.BYTE $0E
		.BYTE $07

		.BYTE $4C		; Lev 17?
		.BYTE $10
		.BYTE $07
		
		.BYTE $4C		; Lev 18?
		.BYTE $12
		.BYTE $07
		
		.BYTE $4C		; Lev 19?
		.BYTE $14
		.BYTE $07
		
		.BYTE $4C		; Lev 20?
		.BYTE $14
		.BYTE $07
		
LBAF4	.BYTE $F0		; 0
		.BYTE $88
		.BYTE $28
		.BYTE $A0
		.BYTE $78
		.BYTE $32
		.BYTE $80
		.BYTE $6C
		.BYTE $44
		.BYTE $80
		.BYTE $60
		.BYTE $4A
		.BYTE $60
		.BYTE $50
		.BYTE $50
		.BYTE $40
		.BYTE $38
		.BYTE $54
		.BYTE $20		; $12
		.BYTE $20
		.BYTE $58

LBB09	.BYTE $FE		; 11111110
		.BYTE $FD		; 11111101
		.BYTE $FF		; 11111111
		.BYTE $01		; 00000001
		.BYTE $03		; 00000011
		.BYTE $05		; 00000101
		.BYTE $07		; 00000111
		.BYTE $06		; 00000110
		
LBB11	.BYTE $FE		; 11111110
		.BYTE $01		; 00000001
		.BYTE $03		; 00000011
		.BYTE $05		; 00000101
		.BYTE $05		; 00000101
		.BYTE $03		; 00000011
		.BYTE $01		; 00000001
		.BYTE $FE		; 11111110

LBB19	.BYTE $C0		; 11000000
		.BYTE $30		; 00110000
		.BYTE $0C		; 00001100
		.BYTE $03		; 00000011
;
; Start X position for base shot
;
BS_STRX
		.BYTE $0A
		.BYTE $51
		.BYTE $95
;
; Missile x,y coordinate on base
;
BSA_POSY
		.BYTE $57		; Missile 0 Pos
BSA_POSX
		.BYTE $9
		.BYTE $59		; Missile 1 Pos
		.BYTE $6
		.BYTE $59		; Missile 2 Pos
		.BYTE $C
		.BYTE $5B		; Missile 3 Pos
		.BYTE $3
		.BYTE $5B		; Missile 4 Pos
		.BYTE $9
		.BYTE $5B		; Missile 5 Pos
		.BYTE $F
		.BYTE $5D		; Missile 6 Pos
		.BYTE $0
		.BYTE $5D		; Missile 7 Pos
		.BYTE $6
		.BYTE $5D		; Missile 8 Pos
		.BYTE $C
		.BYTE $5D		; Missile 9 Pos
		.BYTE $12

BSB_POSY
		.BYTE $57		; Missile 0 Pos
BSB_POSX
		.BYTE $50
		.BYTE $59		; Missile 1 Pos
		.BYTE $4D
		.BYTE $59		; Missile 2 Pos
		.BYTE $53
		.BYTE $5B		; Missile 3 Pos
		.BYTE $4A
		.BYTE $5B		; Missile 4 Pos
		.BYTE $50
		.BYTE $5B		; Missile 5 Pos
		.BYTE $56
		.BYTE $5D		; Missile 6 Pos
		.BYTE $47
		.BYTE $5D		; Missile 7 Pos
		.BYTE $4D
		.BYTE $5D		; Missile 8 Pos
		.BYTE $53
		.BYTE $5D		; Missile 9 Pos
		.BYTE $59

BSC_POSY
		.BYTE $57		; Missile 0 Pos
BSC_POSX
		.BYTE $94
		.BYTE $59		; Missile 1 Pos
		.BYTE $91
		.BYTE $59		; Missile 2 Pos
		.BYTE $97
		.BYTE $5B		; Missile 3 Pos
		.BYTE $8E
		.BYTE $5B		; Missile 4 Pos
		.BYTE $94
		.BYTE $5B		; Missile 5 Pos
		.BYTE $9A
		.BYTE $5D		; Missile 6 Pos
		.BYTE $8B
		.BYTE $5D		; Missile 7 Pos
		.BYTE $91
		.BYTE $5D		; Missile 8 Pos
		.BYTE $97
		.BYTE $5D		; Missile 9 Pos
		.BYTE $9D
;
; Draw buffers
;
DW_BUFLO
		.BYTE $10		; $A10
DW_BUFHI
		.BYTE $0A
		.BYTE $90		; $A90
		.BYTE $0A
		.BYTE $10		; $B10
		.BYTE $0B
		.BYTE $90		; $B90
		.BYTE $0B
;
; City x coordinate on screen
;
; -- Original --
;CITY_X	.BYTE $0E
;		.BYTE $21
;		.BYTE $35
;		.BYTE $62
;		.BYTE $75
;		.BYTE $87

CITY_X	.BYTE $17
		.BYTE $28
		.BYTE $39
		.BYTE $5E
		.BYTE $6E
		.BYTE $7E
;
; City Data
;
CITYDAT
		.BYTE $05		
		.BYTE $04		
		.BYTE $F3		
		.BYTE $FF		
		.BYTE $FF		
		.BYTE $FF		
		.BYTE $F3		
		.BYTE $33		
		.BYTE $FF		
		.BYTE $FF		
		.BYTE $C3		
		.BYTE $30		
		.BYTE $CF		
		.BYTE $FF		
		.BYTE $00		
		.BYTE $00		
		.BYTE $03		
		.BYTE $FF		
		.BYTE $00		
		.BYTE $00		
		.BYTE $00		
		.BYTE $FF		
;
; Base Data
;
BASEDAT
		.BYTE $07		; row
		.BYTE $05		; width
		
		.BYTE $FF		
		.BYTE $00		
		.BYTE $00 ; $03
		.BYTE $3F ; $FF		
     	.BYTE $FF		
     	
		.BYTE $FC		
		.BYTE $00		
		.BYTE $00		
		.BYTE $0F ; $FF		
		.BYTE $FF		
 		
		.BYTE $F0		
		.BYTE $00
     	.BYTE $00
		.BYTE $03 ; $3F		
		.BYTE $FF		
		
		.BYTE $C0		
		.BYTE $00
		.BYTE $00
		.BYTE $00 ; $0F
		.BYTE $FF
 
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $3F ; $FF

		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $00
 
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $00

LBB72					; Bomber (right)
		.BYTE $20
		.BYTE $18
		.BYTE $8C
		.BYTE $FF
		.BYTE $0C
		.BYTE $18
		.BYTE $30
		.BYTE $40
		
LBB7A
		.BYTE $08		; row
		.BYTE $03		; width
		
		.BYTE $F3
		.BYTE $FF
		.BYTE $FF
		
		.BYTE $FC
		.BYTE $3F
		.BYTE $FF
		
		.BYTE $3F
		.BYTE $0F
		.BYTE $FF
		
		.BYTE $00
		.BYTE $00
		.BYTE $FF
		
		.BYTE $FF
		.BYTE $0F
		.BYTE $FF
		
		.BYTE $FC
		.BYTE $3F
		.BYTE $FF
		
		.BYTE $F0
		.BYTE $FF
		.BYTE $FF
		
		.BYTE $CF
		.BYTE $FF
		.BYTE $FF
		
LBB94					; Bomber (left)
		.BYTE $04
		.BYTE $18
		.BYTE $31
		.BYTE $FF
		.BYTE $30
		.BYTE $18
		.BYTE $0C
		.BYTE $02
LBB9C
		.BYTE $08		; row
		.BYTE $03		; width
		
		.BYTE $FF
		.BYTE $CF
		.BYTE $FF
		
		.BYTE $FC
		.BYTE $3F
		.BYTE $FF

		.BYTE $F0
		.BYTE $FC
		.BYTE $FF

		.BYTE $00
		.BYTE $00
		.BYTE $FF

		.BYTE $F0
		.BYTE $FF
		.BYTE $FF

		.BYTE $FC
		.BYTE $3F
		.BYTE $FF

		.BYTE $FF
		.BYTE $0F
		.BYTE $FF

		.BYTE $FF
		.BYTE $F3
		.BYTE $FF

LBBB6					; Alien bomber
		.BYTE $81
		.BYTE $5A
		.BYTE $3C
		.BYTE $7E
		.BYTE $7E
		.BYTE $3C
		.BYTE $5A
		.BYTE $81

LBBBE
		.BYTE $08		; row
		.BYTE $03		; width

		.BYTE $3F
		.BYTE $FC
		.BYTE $FF

		.BYTE $CC
		.BYTE $33
		.BYTE $FF

		.BYTE $F0
		.BYTE $0F
		.BYTE $FF

		.BYTE $C0
		.BYTE $03
		.BYTE $FF

		.BYTE $C0
		.BYTE $03
		.BYTE $FF

		.BYTE $F0
		.BYTE $0F
		.BYTE $FF

		.BYTE $CC
		.BYTE $33
		.BYTE $FF

		.BYTE $3F
		.BYTE $FC
		.BYTE $FF

LBBD8
		.BYTE $10		; Cursor 
		.BYTE $28
		.BYTE $10
LBBDB
		.BYTE $10		; Cursor
		.BYTE $38
		.BYTE $10

SMRT_BMB				; Smart bomb image
		.BYTE $00
SMRT_BM
		.BYTE $F8
		.BYTE $70
		.BYTE $20
		.BYTE $00

X_DATA					; X image
		.BYTE $03
		.BYTE $02
		.BYTE $33
		.BYTE $FF
		.BYTE $CF
		.BYTE $FF
		.BYTE $33
		.BYTE $FF
		
MISSDAT					; Missile image
		.BYTE $03		; row
		.BYTE $02		; width
		
		.BYTE $CF
		.BYTE $FF

		.BYTE $CF
        .BYTE $FF
        
;        .BYTE $CF
;        .BYTE $FF
        
        .BYTE $33
        .BYTE $FF

LBBF5   .BYTE $0F,$C3,$3C
		.BYTE $F0
		.BYTE $FF
        .BYTE $CF
        .BYTE $3F,$3F,$CF,$FC
        .BYTE $3F
        .BYTE $F3,$CF
LBC02   .BYTE $CF,$F3,$3F,$FC
        .BYTE $FC,$03,$FF
		.BYTE $F0
		.BYTE $F0
        .BYTE $FF,$C3,$FC,$3F
        .BYTE $0F,
        .BYTE $FF,$0F,$3F
        .BYTE $FF,$CF,$FF
        .BYTE $00
        .BYTE $FF
   		.BYTE $F0
		.BYTE $FF
        .BYTE $0F,$C3,$FF,$C3
        .BYTE $CF,$FF,
        .BYTE $F3,$3F
        .BYTE $FF,$FC,$3F,$FF
        .BYTE $FC,$FF
		.BYTE $C0
		.BYTE $3F
        .BYTE $FF,$FC,$3F,$C3
        .BYTE $FF,$F3
        .BYTE $FF,$FC
        .BYTE $FF,$CF,$FF,$FF
        .BYTE $3F,$CF
        .BYTE $FF,$FF
        .BYTE $3F,$3F,$FF,$FF
        .BYTE $CF,$3F
        .BYTE $FF,$FF
        .BYTE $CF,$FF
		.BYTE $F0
		.BYTE $0F
        .BYTE $FF,$FF    
        .BYTE $0F
		.BYTE $F0
		.BYTE $FF
        .BYTE $FC,$FF,$FF,$3F
        .BYTE $F3,
        .BYTE $FF,$FF,$CF
        .BYTE $CF,$FF
        .BYTE $FF,$F3,$CF,$FF
        .BYTE $FF,$F3,$3F,$FF
        .BYTE $FF,$FC,$3F  
        .BYTE $FF
        .BYTE $FF,$FC
;
; Array of Missile Command text
;
MS_ARY1
        .WORD LTR_M
        .WORD LTR_I
        .WORD LTR_S
        .WORD LTR_S
        .WORD LTR_I
        .WORD LTR_L
        .WORD LTR_E
MS_ARY2
        .WORD LTR_C
        .WORD LTR_O
        .WORD LTR_M
        .WORD LTR_M
        .WORD LTR_A
        .WORD LTR_N
        .WORD LTR_D
        .WORD LTR_PLS
;
; "M" Data
;
LTR_M        
		.BYTE $E	; Rows
		.BYTE $04	; Width
		
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111
        
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11110000
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11110000
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

;
; "I" Data
;
LTR_I
		.BYTE $E	; Rows
		.BYTE $04	; Width

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111
;
; "S" Data
;
LTR_S
		.BYTE $E	; Rows
		.BYTE $04	; Width

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111
;
; "L" Data
;
LTR_L
		.BYTE $E	; Rows
		.BYTE $04	; Width

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111
;
; "E" Data
;
LTR_E
		.BYTE $E	; Rows
		.BYTE $04	; Width

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111
;
; "C" Data
;
LTR_C
		.BYTE $E	; Rows
		.BYTE $04	; Width

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111
;
; "O" Data
;
LTR_O
		.BYTE $E	; Rows
		.BYTE $04	; Width

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11111111
;
; "A" Data
;
LTR_A
		.BYTE $E	; Rows
		.BYTE $04	; Width

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111
;
; "N" Data
;
LTR_N
		.BYTE $E	; Rows
		.BYTE $04	; Width

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~00001111
		
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~00001111
		
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111
		
		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111
;
; "D" Data
;
LTR_D
		.BYTE $E	; Rows
		.BYTE $04	; Width

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~11111111
		.BYTE ~00000000
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111
		.BYTE ~11111111

;
; "+" Data
;
LTR_PLS
		.BYTE $E	; Rows
		.BYTE $04	; Width

		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~11110000
		.BYTE ~00000000
		.BYTE ~00000000
		.BYTE ~00001111

		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11110000
		.BYTE ~00001111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111
		.BYTE ~11111111

;
; "THE" Data
;
THEDAT        
		.BYTE $0F	; Rows
		.BYTE $0D	; Width

		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF  
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $FF
		.BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF,$FF,$FF
		.BYTE $00
		.BYTE $FF,$FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $FF,$FF,$FF
        .BYTE $FF
        .BYTE $FF
		.BYTE $00
        .BYTE $FF,$FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF,$FF,$FF,$FF
        .BYTE $FF
		.BYTE $00
		.BYTE $FF,$FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF
        .BYTE $FF,$FF,$FF
		.BYTE $FF
		.BYTE $00
        .BYTE $FF,$FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $FF,$FF
        .BYTE $FF
		.BYTE $00
		.BYTE $FF,$FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF,$FF,$FF
		.BYTE $00
		.BYTE $FF
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $FF,$FF,$FF
		.BYTE $00
        .BYTE $FF,$FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $FF,$FF,$FF,$FF
        .BYTE $FF
		.BYTE $00
		.BYTE $FF,$FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $FF,$FF,$FF,$FF
		.BYTE $FF
		.BYTE $00
        .BYTE $FF,$FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $FF,$FF,$FF
        .BYTE $FF
        .BYTE $FF
		.BYTE $00
        .BYTE $FF,$FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF,$FF,$FF
		.BYTE $00
		.BYTE $FF,$FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $FF,$FF,$FF
		.BYTE $00
		.BYTE $FF,$FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $FF,$FF
;
; "END" Data
;
ENDDAT
		.BYTE $0F	; Rows
		.BYTE $0D	; Width
		
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
        .BYTE $0F,$FF,$FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
		.BYTE $00
        .BYTE $03,$FF,$FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $FF
        .BYTE $FF
		.BYTE $00
		.BYTE $FF,$FF,$FF
		.BYTE $00
        .BYTE $3F
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $3F,$FF
		.BYTE $00
        .BYTE $FF   
        .BYTE $FF,$FF
		.BYTE $00
		.BYTE $3F
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $C0
		.BYTE $3F
        .BYTE $FF
		.BYTE $00
		.BYTE $FF,$FF,$FF
		.BYTE $00
        .BYTE $0F
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $F0
		.BYTE $3F
		.BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $0F
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $F0
		.BYTE $3F
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $C3
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $F0
		.BYTE $3F
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
		.BYTE $FF
		.BYTE $00
		.BYTE $F0
		.BYTE $00
		.BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $F0
		.BYTE $3F
        .BYTE $FF
		.BYTE $00
        .BYTE $FF,$FF,$FF
		.BYTE $00
		.BYTE $F0
		.BYTE $00
		.BYTE $FF
		.BYTE $00
		.BYTE $FF
  		.BYTE $F0
		.BYTE $3F
        .BYTE $FF
		.BYTE $00
        .BYTE $FF,$FF,$FF
		.BYTE $00
        .BYTE $FC
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $C0
		.BYTE $3F
        .BYTE $FF
		.BYTE $00
		.BYTE $FF,$FF,$FF
		.BYTE $00
        .BYTE $FC
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
        .BYTE $3F,$FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF,$FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00	
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $03,$FF,$FF
		.BYTE $00
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $00
		.BYTE $0F,$FF,$FF

BNS_LO	.BYTE <BONUS1	; 1x  $BDF9
BNS_HI	.BYTE >BONUS1
		.BYTE <BONUS2	; 2x  $BE19
		.BYTE >BONUS2
		.BYTE <BONUS3	; 3x  $BE39
		.BYTE >BONUS3
		.BYTE <BONUS4	; 4x  $BE59
		.BYTE >BONUS4
		.BYTE <BONUS5	; 5x  $BE79
		.BYTE >BONUS5
		.BYTE <BONUS6	; 6x  $BE99
		.BYTE >BONUS6
		
BONUS1	.BYTE $0A
        .BYTE $03,$FC,$3F,$FF
		.BYTE $F0
		.BYTE $3F
		.BYTE $FF
		.BYTE $C0
		.BYTE $3F
        .BYTE $FF
   		.BYTE $FC
		.BYTE $3F
        .BYTE $FF
        .BYTE $FC
        .BYTE $3F,$FF
        .BYTE $FC,$3F,$FF,$FC
        .BYTE $3F,$FF
        .BYTE $FC,$3F,$FF
        .BYTE $C0,$03
        .BYTE $FF
		.BYTE $C0
		.BYTE $03
        .BYTE $FF

BONUS2
		.BYTE $0A
        .BYTE $03
		.BYTE $C0
		.BYTE $03
        .BYTE $FF
		.BYTE $00
		.BYTE $00
        .BYTE $FF,$0F
		.BYTE $F0
        .BYTE $FF
		.BYTE $FF
		.BYTE $F0
		.BYTE $FF
        .BYTE $FF
		.BYTE $C3,$FF,$FC
        .BYTE $0F,$FF
		.BYTE $F0
		.BYTE $3F
		.BYTE $FF
        .BYTE $C3,$FF,$FF
		.BYTE $00
		.BYTE $00
		.BYTE $FF
		.BYTE $00
		.BYTE $00
        .BYTE $FF

BONUS3
		.BYTE $0A
        .BYTE $03
		.BYTE $C0
		.BYTE $03
		.BYTE $FF
		.BYTE $00
		.BYTE $00
        .BYTE $FF,$0F
   		.BYTE $F0
		.BYTE $FF
        .BYTE $FF
		.BYTE $F0
		.BYTE $FF
        .BYTE $FC
        .BYTE $03,$FF,$FC
		.BYTE $03,$FF,$FF
		.BYTE $F0
		.BYTE $FF
		.BYTE $0F
		.BYTE $F0
		.BYTE $FF
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $C0
		.BYTE $03
        .BYTE $FF

BONUS4
		.BYTE $0A
        .BYTE $03,$0F,$FF,$FF
		.BYTE $0F,$FF
        .BYTE $FF,$0F
		.BYTE $0F,$FF,$0F,$0F
        .BYTE $FF
		.BYTE $00
		.BYTE $03,$FF
		.BYTE $00
        .BYTE $03,$FF,$FF
		.BYTE $0F,$FF
		.BYTE $FF,$0F
        .BYTE $FF,$FF,$0F,$FF
		.BYTE $FF,$0F,$FF

BONUS5
		.BYTE $0A
		.BYTE $03
		.BYTE $00
        .BYTE $03,$FF
		.BYTE $00
		.BYTE $03
        .BYTE $FF,$0F,$FF
		.BYTE $FF,$0F,$FF,$FF
		.BYTE $00
        .BYTE $03,$FF
		.BYTE $00
		.BYTE $00
		.BYTE $FF,$FF
		.BYTE $F0
		.BYTE $FF
        .BYTE $FF
		.BYTE $F0
		.BYTE $FF
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $00
		.BYTE $03,$FF

BONUS6
		.BYTE $0A
        .BYTE $03
		.BYTE $C0
		.BYTE $03
		.BYTE $FF
		.BYTE $00
        .BYTE $03
		.BYTE $FF,$0F,$FF
        .BYTE $FF,$0F,$FF,$FF
		.BYTE $00
		.BYTE $03,$FF
		.BYTE $00
		.BYTE $00
        .BYTE $FF,$0F
		.BYTE $F0
		.BYTE $FF
		.BYTE $0F
		.BYTE $F0
		.BYTE $FF
		.BYTE $00
		.BYTE $00
        .BYTE $FF
		.BYTE $C0
		.BYTE $03
        .BYTE $FF
;
; "BONUS"
;
BONUS
		.BYTE $0A
		.BYTE $13,$FF,$FF,$FC
		.BYTE $00
        .BYTE $3F
		.BYTE $F0
		.BYTE $00
		.BYTE $FF
		.BYTE $00
		.BYTE $0F,$C3,$FC,$3C
		.BYTE $00
        .BYTE $03
		.BYTE $F0
		.BYTE $00
		.BYTE $3F,$FF,$3F,$CF
        .BYTE $FC
		.BYTE $00
        .BYTE $0F
		.BYTE $C0
		.BYTE $00
        .BYTE $3F
		.BYTE $00
        .BYTE $0F
		.BYTE $C3,$FC,$3C
		.BYTE $00
        .BYTE $03
		.BYTE $C0
		.BYTE $00
		.BYTE $3F
        .BYTE $FF,$0F,$0F
		.BYTE $FC,$3F,$C3,$C3
        .BYTE $FC,$3F
		.BYTE $F0
		.BYTE $FF
		.BYTE $C0
		.BYTE $FC
		.BYTE $3F
		.BYTE $F0
		.BYTE $FF
        .BYTE $C3,$FF,$FF,$FF
		.BYTE $C0
		.BYTE $3F
		.BYTE $FC,$3F
        .BYTE $C3,$C3
		.BYTE $FC,$3F
		.BYTE $F0
		.BYTE $FF
		.BYTE $C0
		.BYTE $3C
        .BYTE $3F
		.BYTE $F0
		.BYTE $FF
		.BYTE $C3,$FF,$FF,$FF
		.BYTE $F0
		.BYTE $FF
        .BYTE $FC,$3F,$C3,$C3
		.BYTE $FC,$3F
		.BYTE $F0
		.BYTE $FF
        .BYTE $C3,$0C,$3F
		.BYTE $F0
		.BYTE $FF
		.BYTE $F0
		.BYTE $03
		.BYTE $FF,$FF
		.BYTE $F0
		.BYTE $FF
		.BYTE $FC
		.BYTE $00
        .BYTE $0F
		.BYTE $C3
		.BYTE $FC,$3F
		.BYTE $F0
		.BYTE $FF
        .BYTE $C3,$0C
		.BYTE $3F
		.BYTE $F0
		.BYTE $FF
		.BYTE $FC
		.BYTE $00
        .BYTE $FF,$FF
		.BYTE $C0
		.BYTE $3F
		.BYTE $FC
		.BYTE $00
        .BYTE $3F,$C3,$FC,$3F
		.BYTE $F0
		.BYTE $FF
		.BYTE $C3 
		.BYTE $C0
		.BYTE $3F
   		.BYTE $F0
		.BYTE $FF
        .BYTE $FF,$FC,$3F,$FF
        .BYTE $0F,$0F,$FC,$3F
		.BYTE $FF,$C3,$FC,$3F
		.BYTE $F0
		.BYTE $FF
        .BYTE $C3
 		.BYTE $F0
		.BYTE $3F
		.BYTE $F0
		.BYTE $FF
        .BYTE $FF
        .BYTE $FC,$3F,$FF
		.BYTE $3F,$CF,$FC,$3F
        .BYTE $FF
		.BYTE $C0
		.BYTE $00
		.BYTE $3F
		.BYTE $00
        .BYTE $0F,$C3,$FC,$3F
		.BYTE $F0
		.BYTE $FF
		.BYTE $C0
		.BYTE $00
        .BYTE $3F
		.BYTE $FF,$FF,$FF
		.BYTE $FC
        .BYTE $3F,$FF
		.BYTE $F0
		.BYTE $00
		.BYTE $FF
		.BYTE $00
        .BYTE $0F
		.BYTE $C3,$FC,$3F
		.BYTE $F0
		.BYTE $FF
		.BYTE $C0
		.BYTE $00
        .BYTE $FF     
        .BYTE $FF
		.BYTE $6E
		.BYTE $80
		.BYTE $6D
        .BYTE $2F
		.BYTE $81
		.BYTE $72		
		.BYTE $80

; 
; DISPLAY LIST EQUATES
; 
ADLI     = $0080
AVB      = $0040
ALMS     = $0040
AVSCR    = $0020
AHSCR    = $0010
AJMP     = $0001
AEMPTY1  = $0000
AEMPTY2  = $0010
AEMPTY3  = $0020
AEMPTY4  = $0030
AEMPTY5  = $0040
AEMPTY6  = $0050
AEMPTY7  = $0060
AEMPTY8  = $0070

 *=$BE00
DLIST4
        .BYTE $80		; DLI
        .BYTE $C0
        .BYTE $D0
        .BYTE $D0
        .BYTE $D0
        .BYTE $C6		; mode 6
        .BYTE $04
        .BYTE $10		; $1004
        .BYTE $86		; DLI
        .BYTE $CD
        .BYTE $80		; DLI
        .BYTE $11		; $1180
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
       
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $8D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $8D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        
;        .BYTE $0D
;        .BYTE $0D
;        .BYTE $8D
;        .BYTE $0D

        .BYTE $46		; mode 6
        .BYTE $00
        .BYTE $0F		; $F00

        .BYTE $4D
        .BYTE $80		; DLI
        .BYTE $1B		; $1B80    

        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D

        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $8D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $8D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D

        
        .BYTE $41
        .BYTE <DLIST4
        .BYTE >DLIST4		; Jump DLIST2

 *=$BEA0
;
; Main Display List
;
DL_INTRO
		.BYTE $70		; 8 blank lines
		.BYTE $70		; 8 blank lines
		.BYTE $70		; 8 blank lines
		.BYTE $46		; Antic mode 6
        .BYTE <TXT_MEM
        .BYTE >TXT_MEM  ; Text memory
		.BYTE $86
		.BYTE $06
		.BYTE $86
		.BYTE $06
		.BYTE $86
		.BYTE $06
		.BYTE $46
		.BYTE $00,$0F	; $F00
		.BYTE $86		; 20
		.BYTE $06		; 40
		.BYTE $86		; +60
		.BYTE $06		; +80
		.BYTE $86		; +100
		.BYTE $06		; +120
		.BYTE $86		; +140

		.BYTE $4D		; Antic mode D
		.BYTE $A0
		.BYTE $19		; $19A0

        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $8D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $8D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $41
        .BYTE <DL_INTRO
        .BYTE >DL_INTRO		; Jump DLIST2
         
 *=$BF00
;
; Main Display List
;
DLIST1
		.BYTE $70		; 8 blank lines
		.BYTE $70		; 8 blank lines
		.BYTE $70		; 8 blank lines
		.BYTE $46		; Antic mode 6
        .BYTE $04
		.BYTE $10		; $1004
		.BYTE $06
		.BYTE $06		; 3 lines of mode 6

		.BYTE $4D		; Antic mode D
		.BYTE $20				
		.BYTE $12		; $1220
		.BYTE $01				
		.BYTE <DLIST3				
		.BYTE >DLIST3	; Jump to DLIST3
		.BYTE $66				
		.BYTE $68				
DLIST2
        .BYTE $80		; DLI
        .BYTE $C0
        .BYTE $D0
        .BYTE $D0
        .BYTE $D0
        .BYTE $C6		; mode 6
        .BYTE $04
        .BYTE $10		; $1004
        .BYTE $86		; DLI
        .BYTE $CD
        .BYTE $80		; DLI
        .BYTE $11		; $1180
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
DLIST3
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $8D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $8D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $8D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $8D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $8D
        .BYTE $0D
        .BYTE $0D
        .BYTE $41
        .BYTE <DLIST2
        .BYTE >DLIST2		; Jump DLIST2

KEYCODE  .BYTE $6C,$6A,$3B,$80	; 0
         .BYTE $80,$6B,$2B,$2A
         .BYTE $6F,$80,$70,$75	; 8
         .BYTE $9B,$69,$2D,$3D
         .BYTE $76,$80,$63,$80	; 16
         .BYTE $80,$62,$78,$7A
         .BYTE $34,$80,$33,$36	; 24
         .BYTE $1B,$35,$32,$31
         .BYTE $2C,$20,$2E,$6E	; 32
         .BYTE $80,$6D,$2F,$81
         .BYTE $72,$80,$65,$79	; 40
         .BYTE $7F,$74,$77,$71
         .BYTE $39,$80,$30,$37	; 48
         .BYTE $7E,$38,$3C,$3E
         .BYTE $66,$68,$64,$80
         .BYTE $82,$67,$73,$61

 .IF ATARI_8
;--------------------------------------
; Atari 8 Bit
;--------------------------------------

 *=$BFFA
        .BYTE <KEYVEC
        .BYTE >KEYVEC
        .BYTE $00
        .BYTE $04
        .BYTE <STRGAME
        .BYTE >STRGAME
 .ELSE
;--------------------------------------
; Atari 5200
;--------------------------------------

 *=CARTNM
		.BYTE $40
		.BYTE $40
		.BYTE $6D		; Missile
		.BYTE $69
		.BYTE $73
		.BYTE $73
		.BYTE $69
		.BYTE $6C
		.BYTE $65
		.BYTE $40
		.BYTE $63		; Command
		.BYTE $6F
		.BYTE $6D
		.BYTE $6D
		.BYTE $61
		.BYTE $6E
		.BYTE $64
        .BYTE $4B
		.BYTE $40
		.BYTE $40

 *=COPYD
        .BYTE $40
        .BYTE $40
        .BYTE <STRGAME
        .BYTE >STRGAME
 .ENDIF
;--------------------------------------

         .END